
/* ------  GLOBALS  ------- */


semaphore   := vlOnOff.On;
current_tech := " ";
current_lib := " ";
current_design := " ";
current_module := "none";
current_outnet := " ";
current_report := " ";
current_outdir := ":";
declare sys;

VHDLDES := "vhdldes";
RETARGETER := "retargeter";

  /* variables needed for creating constraint table */

    in_no := 0;
    out_no := 0;
    max_inout := 512;
    max_time := "none";

    con_value := max_time;
    in := make_vector(max_inout);
    out := make_vector(max_inout);
    in_arrive_rise := make_vector(max_inout,"0");
    in_arrive_fall := make_vector(max_inout,"0");
    out_require_rise := make_vector(max_inout,max_time);
    out_require_fall := make_vector(max_inout,max_time);
    in_load := make_vector(max_inout,max_time);
    out_load := make_vector(max_inout,max_time);
    in_drive_rise := make_vector(max_inout,max_time);
    in_drive_fall := make_vector(max_inout,max_time);
    in_bar_value:= make_vector(max_inout,max_time);
    out_bar_value := make_vector(max_inout,max_time);
    arrive_time := make_vector(max_inout,max_time);
    require_time := make_vector(max_inout,max_time);

/* variables for settting package */

declare new_voltage;
declare new_temperature;
declare current_temperature;
declare current_voltage;
declare current_process_type;
declare current_logic_type;
declare current_package;
declare new_process_type;
declare new_logic_type;
declare new_package;
empty_package :="default_package";


/* Utility functions */

/* jrs 11/4/92 */
function append1(list1, item) {
   return (reverse(cons(item,reverse(list1)))); }
/* end jrs */

 
iterator from_to(first, last)
        for (i := first; i < last; ++i)
            iterate (i);

function fprintf(args...)
    fputline (car (args), apply (sprintf, cdr (args)));


function logarithmic_scalebar(name, val, min, max, call_on_change) {

ok_to_update := TRUE;
function to_scale(x) {
    temp_value := 0.0;
    time_value := 0.0;

    time_value = x;  
    if (time_value <= 250)
        temp_value = time_value/25;
    else if (time_value <= 500)
             temp_value = (time_value - 180.77)/6.38;
         else if (time_value <= 750)
                  temp_value = (time_value - 415.83)/1.67;
              else if (time_value <= 1000)
                       temp_value = (time_value - 688.288)/0.312;
    
    if( temp_value > 999.0) return(max_time);  
    if( temp_value < 0.05 ) temp_value = 0.0;
    return( convert(string, temp_value));
 }
function from_scale(val) {
    declare value;

    /* fix to allow typing in "." */
    
    if( string_eq( val, max_time )) return(1000.0);
    x  := string2number( val ); 

    if ( x < 0.0 ) value = 0.0;
    if ( x <=10.00 )
         value = x * 25;
    else if ( x <= 50 )
              value = x * 6.38 + 180.77;
    else if ( x <= 200 )
              value = x * 1.67 + 415.83;
    else if ( x <= 1000 )
              value = x * 0.312 + 688.288;
    return( value );
} 


    cmdline := vcRegion.Create (name + "_cmdline", vcCmdline.fac, val,
                                max_width <- 10);
    scalebar := vcRegion.Create (name + "_scalebar", vcScalebar.fac,
                                 from_scale (val),
                                 min <- min,
                                 max <- max,
                                 increment <- 0.01 ,
                                 range <- FALSE,
                                 value <- FALSE,
                                 ticks <- 0);

    vcScale.NotifyOnChange (scalebar,
                            func(v) {
                              if( ok_to_update ) {
                                ok_to_update = FALSE;
                                vcCmdline.Set (cmdline, to_scale(v));
                                ok_to_update = TRUE; } 
                            });
    vcCmdline.CallOnChange (cmdline, func(str) {
        ok_to_update = FALSE;
        len := string_length (str);
        if ( (len > 0) && (string_ref( str, len-1 ) != '.' )) {
            errstr := vcWv.ErrorCheck (func() {
            vcScalebar.Set (scalebar, from_scale (str));
            call_on_change ( str ); 
            });
            if (errstr != nil) {
                w := vcRegion.Window (cmdline);
                vcWin.ClearStatus (w);
                vcWin.AddStatus (w, errstr);
            } /* if */
        } /* if */
        ok_to_update = TRUE;
    });
    tt :=vcTable.Make (name, 1, 4,
                  cmdline,
                  vcRegion.Create ("", vcLabel.fac, min),
                  scalebar,
                  vcRegion.Create ("", vcLabel.fac, max));
    return(tt);
} /* function logarithmic_scalebar */

function logscale_set(logscale, val) {

    cmdline := vcTable.Get (logscale, 0, 0);
    vcCmdline.Set (cmdline, val);
}
function stringregion_set(table, val) {

    cmdline := vcTable.Get (table, 0, 1);
    vcCmdline.Set (cmdline, val);
}

/* A region with  a label and value which is not changeable */
function informregion (strlist) {
   declare oneitem, title, initval;
   table := vcTable.Create ("stringregion", 1, 2);
   for (; !null (strlist); strlist = cdr (strlist)) {
      oneitem  = car (strlist);
      title    = car (oneitem); oneitem = cdr (oneitem);
      initval  = car (oneitem);
      vcTable.Add (table, vcRegion.Create1 (title, vcLabel.fac, title, nil))
;
      t_typein := vcRegion.Create1 (title + ".string", vcCmdline.fac, initval,
         list (width <- 5, macro_on <- TRUE));
      vcTable.Add (table, t_typein);
      vcCmdline.CallOnChange (t_typein, func(s){vcCmdline.Set(t_typein, initval);}); }
   vcTable.Col (table, 0, vcTable.Border.Invisible, 1,1,1, vgAlign.MiddleRight);
   return (table); }


/* A region with some number of string entry widgets in a vertical row */
function stringregion (strlist) {
   declare oneitem, callback, title, initval;
   table := vcTable.Create ("stringregion", 1, 2);
   for (; !null (strlist); strlist = cdr (strlist)) {
      oneitem  = car (strlist);
      callback = car (oneitem); oneitem = cdr (oneitem);
      title    = car (oneitem); oneitem = cdr (oneitem);
      initval  = car (oneitem);
      vcTable.Add (table, vcRegion.Create1 (title, vcLabel.fac, title, nil));
      t_typein := vcRegion.Create1 (title + ".string", vcCmdline.fac, initval,
         list (width <- 5, macro_on <- TRUE));
      vcTable.Add (table, t_typein);
      vcCmdline.CallOnChange (t_typein, callback); }
   vcTable.Col (table, 0, vcTable.Border.Invisible, 1,1,1, vgAlign.MiddleRight);
   return (table); }

/* A region with a input string and a title button */

function stringbutton (strlist) {
   declare oneitem, callback, accept, title, initval;


   table := vcTable.Create ("stringregion", 1, 2);
   for (; !null (strlist); strlist = cdr (strlist)) {
      oneitem  = car (strlist);
      callback = car (oneitem); oneitem = cdr (oneitem);
      accept = car (oneitem); oneitem = cdr (oneitem);
      title    = car (oneitem); oneitem = cdr (oneitem);
      initval  = car (oneitem);
      b_accept := vcWv.LabelButtonCreate (title + ".a", title, nil, accept,
                list (macro_on <- TRUE));
      vcTable.Add (table, b_accept);
      t_typein := vcRegion.Create1 (title + ".string", vcCmdline.fac, initval,
         list (width <- 20, macro_on <- TRUE));
      vcTable.Add (table, t_typein);
      vcCmdline.CallOnChange (t_typein, callback); }
   return (table); }



/* A single select horizontal picklist built from a list */

function flatregion (title, callback, initval, flatlist) {
   function flatnotify (data, onoff) {
      if (onoff == vlOnOff.On) callback (car (data)); 
   }

   r_flat := vcRegion.Create1 (title + ".flat", vcPicklist.fac, nil,
      list (macro_on <- TRUE));
   for (i:=flatlist; !null(i); i = cdr (i))
      vcPicklist.Add (r_flat, caar (i), cdar (i));
   setpickmatch (r_flat, flatlist, initval);
   vcPicklist.Notify (r_flat, flatnotify);

   t_top := vcTable.Create ("flatop", 1, 2);
   vcTable.Add (t_top, vcRegion.Create1 ("flatitle", vcStaticText.fac,
      title, nil));
   vcTable.Add (t_top, r_flat);
   return (t_top); 
}

/* Given a region and a picklist, initialize the picklist to the entry matching
   the initial value */
function setpickmatch (region, matchlist, text) {
   declare i, j;
   for (i=0, j=matchlist; !null(j); j=cdr(j), ++i)
      if (string_eq (cadar (j), text))
         return (vcPicklist.SetPick (region, i)); }


/*
 * Provide the essential Create method for the facility.  In it, just
 * instantiate a Shell, run /bin/csh, and we're on our way!
 */

/*
 * This function is a "command generator".  Given a list of argument
 * descriptors, as documented in vcWv.Param, it builds a command that
 * appends its arguments together, separated by spaces, and sends the
 * command to the subprocess.
 */
function cmd(cmdname, abbrev, title, params) {
    function send_strings (args...) {
        declare str, sh, e, a;

        sh  = car (args); args = cdr (args);
        e   = car (args); args = cdr (args);
        for (str = abbrev; !null(args); args = cdr (args)) {
            a = car (args);
            str = str + " " + 
                (istype (a, string) ? a : number2string (a));
        } /* for */
        vcShell.TypeIn (sh, str, TRUE);
    } /* function send_strings */
    vcCmd.Create (fac, send_strings, cmdname, title, params);
} /* function cmd */

/* Create a dialog box window with 3-button bottom row */
function putwindow (cb_action, cb_cancel, region, title) {
   declare window;
   function cancel () {
      vcWin.Destroy (window); semaphore = vlOnOff.On; cb_cancel (TRUE); }
   function action () {  cb_action (); }
   function accept () {  action (); cancel(); }

   b_accept := vcWv.LabelButtonCreate (title + ".a", "Accept", nil, accept,
      list (macro_on <- TRUE));
   b_apply  := vcWv.LabelButtonCreate (title + ".b", "Apply",  nil, action,
      list (macro_on <- TRUE));
   b_cancel := vcWv.LabelButtonCreate (title + ".c", "Cancel", nil, cancel,
      list (macro_on <- TRUE));

   t_buttons := vcTable.Create ("t_buttons", 1, 3);
   vcTable.Add (t_buttons, b_accept);
   vcTable.Add (t_buttons, b_apply);
   vcTable.Add (t_buttons, b_cancel);

   t_top := vcTable.Create (title, 2, 1);
   vcTable.Add (t_top, region);
   vcTable.Add (t_top, t_buttons);

   window = vcWin.Create (t_top,
      vcWin.NoMenus + vcWin.NoCmdline + vcWin.NoStatus);
   vcWin.DestroyNotify (window,
      func (e) { semaphore = vlOnOff.On; cb_cancel (TRUE); });
   if (semaphore == vlOnOff.Off) {
      vcRegion.Enable (b_accept, vlOnOff.Off, TRUE);
      vcRegion.Enable (b_apply,  vlOnOff.Off, TRUE);
   }
   return (list (b_accept, b_apply, window)); 
} 


 
declare vdes_shell;
declare vhdl_files_tab1;
list_vhdl_init := 0;
declare vhd_picklist;
declare vhdl_status;
declare tech_status;
   

function readpins( call_when_done ) {

    if( fexists( spins_file )) {
       in_no = 0;
       out_no = 0;
       fp := fopen( pins_file, "r");
       while (!((line := fgetline (fp)) == nil)) {
          line_length := string_length (line);
          for (index := 0; index < line_length; ++index) {
              previous_index := 0;
              if (string_ref (line, index) == ' ') { /* if#1 */
                  token := substring (line, previous_index, index);
                  if( string_eq (token, "ERROR" )) return(1);
                  if( string_eq (token, "MODULE" )) {
                      previous_index := index + 1;
                      current_module = substring (line, previous_index, 
                                                  line_length);
                  }
                  if( string_eq (token, "I" )) {     /* if#2 */
                      previous_index := index + 1;
                      token := substring (line, previous_index, line_length);
                      vector_set( in, in_no, token );
                      ++in_no;
                  }
                  if( string_eq (token, "O" )) {     /* if#2 */
                      previous_index := index + 1;
                      token := substring (line, previous_index, line_length);
                      vector_set( out, out_no, token );
                      ++out_no;
                  }
             }   
         } /* end of line */
       } /* end of file */

       fclose( fp );
       if( in_no > 0 || out_no > 0 ) {
           current_outnet =  current_module;
           current_report =  current_module;
           call_when_done(); }
    }
    else 
       vcWv.Timer( wv, 1000, func() { readpins( call_when_done);}, FALSE);

} /* end of readpins */



function call_synth( args...){

        vcShell.TypeIn(vdes_shell, "synthesize", TRUE);
        vcCmd.Enable (synth_cmd,            vlOnOff.Off);
        vcCmd.Enable (resynth_cmd,            vlOnOff.On);
        vcCmd.Enable (wire_cmd,               vlOnOff.On);
        vcCmd.Enable (outdir_cmd,               vlOnOff.On);
        vcCmd.Enable (report_cmd,             vlOnOff.On);
        vcWin.UpdateMenus (vdes2_win);
}

function call_resynth( args...  ) {

        vcShell.TypeIn(vdes_shell, "resynthesize", TRUE);
}

function call_map( args... ) {

        vcShell.TypeIn(vdes_shell, "map", TRUE);
        vcCmd.Enable (wire_cmd,            vlOnOff.On);
        vcCmd.Enable (outdir_cmd,               vlOnOff.On); 
        vcCmd.Enable (report_cmd,            vlOnOff.On);
        vcWin.UpdateMenus (vdes2_win);
}


function clear_vhdl() {
	vcShell.TypeIn (vdes_shell, "clear_vhdl", TRUE );
}


function call_area_speed() {
        str := vcRegion.Get(area_bar, string);

/* The following should be used if the scroll bar value is vlOnOff.On.
        str := vcRegion.Get(area_bar, string);    */

        vcShell.TypeIn(vdes_shell, "area/speed "+str, TRUE);
}

function call_max_delay() {

        if (string_eq(con_value, max_time))
           vcShell.TypeIn(vdes_shell, "output_required -1 *", TRUE);
        else vcShell.TypeIn(vdes_shell, "-max_delay "+con_value, TRUE);
}

function call_max_delay_zero( args... ) {

        vcScalebar.set( con_bar, 0);
        vcShell.TypeIn(vdes_shell, "-max_delay 0", TRUE);
}

function call_clear_con( d,e ) {
        vcShell.TypeIn(vdes_shell, "output_required *", TRUE);
}

function call_hist( d, e ) {
        vcShell.TypeIn (vdes_shell, "history", TRUE );
}


changing := FALSE;
declare area_bar;
declare area_cmdline;
declare con_bar;
declare con_cmdline;
declare letter;
/*
declare speed_bar;
*/
area_speed := 1;
temp_value := 1;
last_area_speed := area_speed;
function area_bar_changed(v) {
    if (!changing) {
	area_speed = v;     /*convert (vlPositiveIntVT, v); */
	changing = FALSE;
    }
}


function update_areabar(str) {

    if (!changing ) {
        changing = TRUE;
        area_speed = convert( integer, str );
        if( !(area_speed >=1 && area_speed <= 100 )) {
            area_speed = 1;
            vcCmdline.Set(area_cmdline, "     "+number2string(area_speed));
        }
        vcScalebar.set( area_bar, area_speed );
        changing = FALSE;
    }
}

syn_did := 0;
function enable_syn() {
    if (string_eq(current_design, " " ) || string_eq(current_tech, " " ))
       {
       vcCmd.Enable (synth_cmd,            vlOnOff.Off);
       vcCmd.Enable (resynth_cmd,            vlOnOff.Off);
       vcCmd.Enable (map_cmd,            vlOnOff.Off);
       vcWin.UpdateMenus (vdes2_win);
    }
        
    else {
	syn_did = 0;
       vcCmd.Enable (synth_cmd,            vlOnOff.On);
       vcCmd.Enable (resynth_cmd,            vlOnOff.Off);
       vcCmd.Enable (map_cmd,            vlOnOff.On);
       vcCmd.Enable (wire_cmd,            vlOnOff.Off);
       vcCmd.Enable (outdir_cmd,               vlOnOff.On);
       vcCmd.Enable (report_cmd,            vlOnOff.Off);
       vcWin.UpdateMenus (vdes2_win);
    
    }
}

function init_sfile() {

    if( pins_file != nil && pack_file != nil && cons_file != nil ) {
        spins_file = pins_file + "s";
        spack_file = pack_file + "s";
        scons_file = cons_file + "s";
    }
    else {
        set_stdout(TRUE);
        print("***ERROR:  Can NOT produce syn files");
    }
}
    
   
function ini_package() {

   declare token, line; 
   current_temperature = 25.0;
   current_voltage = 5.0;
   current_process_type = "typical";
   current_logic_type = "mixed";
   current_package = empty_package;
   new_process_type = "typical";
   new_logic_type = "mixed";
   new_package = empty_package;
   fp := fopen( v2.pack_file, "r");
   line := fgetline (fp);
   fclose( fp );
   if( line != nil ) {
      token := substring (line, 0, 3 );
      if( string_eq (token, "ERR" )) return(1);
      else return( 0 );
   }
   else return( 1 );
} 

declare w;
declare filename;
function check_packfile( call_when_done ) {
      if( fexists( spack_file ))
          call_when_done();
        else
          vcWv.Timer( wv, 1000, func(){check_packfile( call_when_done);}
                        , FALSE);
}

function pre_tech() {
      vscript.vsDelete( spack_file, vscript.vsFILE );
      current_tech = " ";
      vcCmd.Enable(set_points_cmd,      vlOnOff.Off); 
      vcCmd.Enable(synth_cmd,            vlOnOff.Off);
      vcCmd.Enable (resynth_cmd,            vlOnOff.Off);
      vcCmd.Enable (wire_cmd,            vlOnOff.Off);
      vcCmd.Enable (outdir_cmd,            vlOnOff.Off);
      vcCmd.Enable (report_cmd,            vlOnOff.Off);
      vcCmd.Enable (show_report_cmd,            vlOnOff.Off);
      vcCmd.Enable (map_cmd,            vlOnOff.Off);
      vcWin.UpdateMenus (vdes2_win);
}

function post_tech( tech) {
      if(ini_package() == 0) {
         current_tech = tech;
         vcCmd.Enable( set_points_cmd, vlOnOff.On);
         enable_syn();
         if( !string_eq(current_design, " " ) ) {
             vcCmd.Enable(synth_cmd,            vlOnOff.On);
             vcCmd.Enable (map_cmd,            vlOnOff.On);
         }
         vcWin.UpdateMenus (vdes2_win);
      }
}
 
function call_show_report( d, e ) {

  declare window;
  declare reg;

        report_file = "temp.log";
        t_top := vcTable.Create ("show_report", 1, 1);
        reg = vcRegion.Create1 ("Shell", vcShell.fac, "/bin/csh", nil);
        vcTable.Add( t_top, reg );
        window = vcWin.Create (t_top,
                 vcWin.NoMenus + vcWin.NoCmdline + vcWin.NoStatus);
        vcShell.TypeIn (reg, "more " + report_file, TRUE);

} /* call_show_report */

     
input_cons_type := "rsfa"; output_cons_type := "rsfa";

function call_set_constraint( d, e ) {

declare load_cons_file;
declare save_cons_file;

    function load_cons( filename) {
  
        declare pos;

        function findpin( str, flg ) {
           
            if( string_eq(flg, "I" )) {
                for( j :=0; j < in_no; ++j )  
                     if( string_eq( vector_ref( in, j ), str )) {
                         return(j); }
                 }
            else if( string_eq(flg, "O" )) { 
                     for( j :=0; j < out_no; ++j )
                          if( string_eq( vector_ref( out, j ), str )) return(j); }
            return( -1 );
        }
      function init_cons() { 
       /* reinitialize constrain vectors */

       for(i := 0; i < in_no; ++i ) {
           vector_set( in_arrive_rise, i, "0" );
           vector_set( in_arrive_fall, i, "0" );
           vector_set( in_drive_rise, i, max_time );
           vector_set( in_drive_fall, i, max_time );
           vector_set( in_load, i, max_time );
       }
       for(i := 0; i < out_no; ++i ) {
           vector_set( out_require_rise, i, max_time );
           vector_set( out_require_fall, i, max_time );
           vector_set( out_load, i, max_time );
       }
     }

     function set_cons_all( pin_name, type, val1, val2 ) {
        if( !char_eq( pin_name[0], '*') ) return( -1 ); 
        if( string_eq (type, "input_arrival" )) 
            for( i := 0; i < in_no; ++i ) {
                 vector_set(in_arrive_rise, i, val1 );
                 vector_set(in_arrive_fall, i, val2 ); }
        if( string_eq (type, "input_drive" )) 
            for( i := 0; i < in_no; ++i ) {
                 vector_set(in_drive_rise, i, val1 );
                 vector_set(in_drive_fall, i, val2 ); }
        if( string_eq (type, "input_load" ))
            for( i := 0; i < in_no; ++i )
                 vector_set(in_load, i, val1 );
        if( string_eq (type, "output_required" ))
            for( i := 0; i < out_no; ++i ) {
                 vector_set(out_require_rise, i, val1 );
                 vector_set(out_require_fall, i, val2 ); }
        if( string_eq (type, "output_load" ))
            for( i := 0; i < out_no; ++i ) 
                 vector_set(out_load, i, val1 );
        return( 1 );
      } /* set_cons_all */

 


    init_cons();
    fp := fopen( filename, "r");
    while (!((line := fgetline (fp)) == nil)) {
        line_length := string_length (line);
        for (index := 0; index < line_length; ++index) {
              previous_index := 0;
              if (string_ref (line, index) == ' ') { /* if#1 */
                  token := substring (line, previous_index, index); 
                  if( string_eq (token, "input_arrival" )) {     /* if#2 */
                      previous_index := index + 1;
                      for (++index; index < line_length; ++index) {
                           if (string_ref (line, index) == ' ') {
                           val1 := substring (line, previous_index, index);
                           previous_index := index + 1;
                           for (++index; index < line_length; ++index) {
                           if (string_ref (line, index) == ' ') {
                           val2 := substring (line, previous_index, index);
                           previous_index := index + 1;
                           name := substring (line, previous_index, line_length);
                           if( set_cons_all( name, token, val1, val2 ) < 0 ) {
                           pos = findpin( name, "I" );
                           if( pos >= 0 )  {  
                                vector_set(in_arrive_rise, pos, val1 ); 
                                vector_set(in_arrive_fall, pos, val2 ); 
                           } }
                   }}}}}
                  if( string_eq (token, "input_drive" )) {     /* if#2 */
                      previous_index := index + 1;
                      for (++index; index < line_length; ++index) {
                           if (string_ref (line, index) == ' ') {
                           val1 := substring (line, previous_index, index);
                           previous_index := index + 1;
                           for (++index; index < line_length; ++index) {
                           if (string_ref (line, index) == ' ') {
                           val2 := substring (line, previous_index, index);
                           previous_index := index + 1;
                           name := substring (line, previous_index, line_length);
                           if( set_cons_all(  name, token, val1, val2 ) < 0 ) {
                           pos = findpin( name, "I" );
                           if( pos >= 0 ) {  
                                vector_set(in_drive_rise, pos, val1 );
                                vector_set(in_drive_fall, pos, val2 );
                           }}
                   }}}}}
                   if( string_eq (token, "max_input_load" )) {     /* if#2 */
                      previous_index := index + 1;
                      for (++index; index < line_length; ++index) {
                           if (string_ref (line, index) == ' ') {
                           val1 := substring (line, previous_index, index);
                           previous_index := index + 1;
                           name := substring (line, previous_index, line_length);
                           if( set_cons_all( name, token, val1, val2 ) < 0 ) {
                           pos = findpin( name, "I" ); 
                           if( pos >= 0 ) 
                                vector_set(in_load, pos, val1 );
                           }
                   }}}
                  if( string_eq (token, "output_required" )) {     /* if#2 */
                      previous_index := index + 1;
                      for (++index; index < line_length; ++index) {
                           if (string_ref (line, index) == ' ') {
                           val1 := substring (line, previous_index, index);
                           previous_index := index + 1;
                           for (++index; index < line_length; ++index) {
                           if (string_ref (line, index) == ' ') {
                           val2 := substring (line, previous_index, index);
                           previous_index := index + 1;
                           name := substring (line, previous_index, line_length);
                           if( set_cons_all( name, token, val1, val2 ) < 0 ) {
                           pos = findpin( name, "O" ); 
                           if( pos >= 0 ){
                                vector_set(out_require_rise, pos, val1 );
                                vector_set(out_require_fall, pos, val2 );
                           }}
                   }}}}}
                   if( string_eq (token, "output_load" )) {     /* if#2 */
                      previous_index := index + 1;
                      for (++index; index < line_length; ++index) {
                           if (string_ref (line, index) == ' ') {
                           val1 := substring (line, previous_index, index);
                           previous_index := index + 1;
                           name := substring (line, previous_index, line_length);
                           if( set_cons_all(  name, token, val1, val2 ) < 0 ) {
                           pos = findpin( name, "O" );
                           if( pos >= 0 ) 
                                vector_set(out_load, pos, val1 );
                           }
                   }}}

              } /* end of if#1 */
         } /* end of line */
     } /* end of file */
     fclose( fp );
     }
     

    in_name_reg := make_vector(in_no);
    in_cmdline_reg := make_vector(in_no);
    in_bar_reg := make_vector(in_no);
    in_load_reg := make_vector(in_no);
    in_drive_rise_reg := make_vector(in_no);
    in_drive_fall_reg := make_vector(in_no);
    label_drive_reg := make_vector(in_no);
    label_load_reg := make_vector(in_no);
    label_arrive_reg := make_vector(in_no);

    /* create output constraint table */

    out_name_reg := make_vector(out_no);
    out_cmdline_reg := make_vector(out_no);
    out_bar_reg := make_vector(out_no);
    out_load_reg := make_vector(out_no);
    out_require_reg := make_vector(out_no);
    labelout_load_reg := make_vector(out_no);
    labelout_require_reg := make_vector(out_no);


    function update_arrive_table(s) {

         if( string_eq(s, "rsfa") || string_eq(s, "rise") ){ 
             for( i:=0; i < in_no; ++i ){
                  logscale_set(vector_ref(in_bar_reg, i), 
                                vector_ref(in_arrive_rise, i));
             }
         }
         else {
             for( i:=0; i < in_no; ++i ) {
                  logscale_set(vector_ref(in_bar_reg, i),
                                vector_ref(in_arrive_fall, i));
             }
        }

    }

    function update_require_table(s) {

         if( string_eq(s, "rsfa") || string_eq(s, "rise") ) 
             for( i:=0; i < out_no; ++i ) 
                  logscale_set(vector_ref(out_bar_reg, i),  
                                vector_ref(out_require_rise, i));
         else
             for( i:=0; i < out_no; ++i )
                  logscale_set(vector_ref(out_bar_reg, i), 
                                vector_ref(out_require_fall, i));
    }

    function call_clear_arrival() {
         for( i:=0; i < in_no; ++i )
              logscale_set(vector_ref(in_bar_reg, i), 
                            0);

    }

    function call_clear_require() {
         for( i:=0; i < out_no; ++i )
              logscale_set(vector_ref(out_bar_reg, i), 
                            max_time);
    }

    function in_bar_changed(i) {
        

         if (!changing ) {
             if( string_eq(input_cons_type, "rsfa")) {
                 vector_set( in_arrive_rise, i, vector_ref(arrive_time,i) );
                 vector_set( in_arrive_fall, i, vector_ref(arrive_time,i)); }
             else if( string_eq(input_cons_type, "rise"))
                      vector_set( in_arrive_rise, i, vector_ref(arrive_time,i));
             else
                      vector_set( in_arrive_fall, i, vector_ref(arrive_time,i) );              
             changing = FALSE;
         }
    }

    function out_bar_changed(i) {

         declare tt;

         if (!changing ) {
             if( string_eq(output_cons_type, "rsfa")) {
                 vector_set( out_require_rise, i, vector_ref(require_time,i));
                 vector_set( out_require_fall, i, vector_ref(require_time,i));}
             else if( string_eq(output_cons_type, "rise"))
                      vector_set( out_require_rise, i, vector_ref(require_time,i));
             else
                      vector_set( out_require_fall, i,vector_ref(require_time,i));
            changing = FALSE;
        }
    }

   function check_consfile( call_when_done ) {
        if( fexists( scons_file ))
            call_when_done();
        else 
            vcWv.Timer( wv, 1000, func(){check_consfile( call_when_done);}
                        , FALSE);
   }
        
 
   function create_cons_table () {

         /* set up initial value of arrival time */

         in_table := vcTable.Create("input constraint", in_no+1, 7 );
                         
         foreach( i; from_to (0, in_no)) {

             /* set up initial value of arrival time */

              if( string_eq(input_cons_type, "fall")) 
                  vector_set(arrive_time ,i, vector_ref(in_arrive_fall, i));
              else
                  vector_set(arrive_time ,i, vector_ref(in_arrive_rise, i));
              

              vector_set(label_arrive_reg, i, vcRegion.Create ("", 
                     vcLabel.fac, "  arrival time: "));
              vector_set(label_drive_reg, i, vcRegion.Create ("", 
                     vcLabel.fac, " drive: "));
              vector_set(in_name_reg, i , vcRegion.Create ("", vcLabel.fac, 
                     vector_ref( in, i))); 
              vector_set(label_arrive_reg, i, vcRegion.Create1 ("arrival time:", 
                         vcLabel.fac, "arrival time:", nil));
              vector_set(in_bar_reg, i, logarithmic_scalebar( "bar",
                  vector_ref(arrive_time,i), 0, 1000, func(str) { 
                  vector_set(arrive_time,i,str);in_bar_changed(i);})); 
              vector_set(in_load_reg, i, stringregion (list (
                list (func (s) { vector_set( in_load, i, s); }, 
                "load:", vector_ref(in_load,i)))));
              vector_set(in_drive_rise_reg, i, stringregion (list (
                list (func (s) { vector_set( in_drive_rise, i, s); }, 
                "rise ", vector_ref(in_drive_rise,i)))));

              vector_set(in_drive_fall_reg, i, stringregion (list (
                list (func (s) { vector_set( in_drive_fall, i, s); }, 
                "fall ", vector_ref(in_drive_fall,i)))));

              
              vcTable.Add( in_table, vector_ref(in_name_reg, i));
              vcTable.Add( in_table, vector_ref(label_arrive_reg, i));
              vcTable.Add( in_table, vector_ref(in_bar_reg, i));
              vcTable.Add( in_table, vector_ref(in_load_reg, i));
              vcTable.Add( in_table, vector_ref(label_drive_reg, i));
              vcTable.Add( in_table, vector_ref( in_drive_rise_reg, i) );
              vcTable.Add( in_table, vector_ref( in_drive_fall_reg, i) );
         }
         
         scrolled_region1 := vcTable.Scroll ("in", in_table, in_table, 
                             1, 8, 10 );

         /* create output constraint table */

         out_table := vcTable.Create("output constraint", out_no+1, 4 );


         foreach( i; from_to(0, out_no) ) {

              if( string_eq(output_cons_type, "fall")) 
                  vector_set(require_time , i, vector_ref(out_require_fall, i));
              else
                  vector_set(require_time , i, vector_ref(out_require_rise, i));
 

              vector_set(labelout_require_reg, i, vcRegion.Create ("",
                     vcLabel.fac, "  require time: "));
              vector_set(out_name_reg, i , vcRegion.Create ("", vcLabel.fac,
                     vector_ref( out, i)));
              vector_set(labelout_require_reg, i, vcRegion.Create1 ("required time:",
                          vcLabel.fac, "required time:", nil));


              vector_set(out_bar_reg,i,logarithmic_scalebar("bar", 
                       vector_ref(require_time,i), 0, 1000, 
                        func(str) {vector_set(require_time,i,str);
                                 out_bar_changed(i);}));
              vector_set(out_load_reg, i, stringregion (list (
                list (func (s) { vector_set( out_load, i, s); },
                "load ", vector_ref(out_load,i)))));


              vcTable.Add( out_table, vector_ref(out_name_reg, i));
              vcTable.Add( out_table, vector_ref(labelout_require_reg, i));
              vcTable.Add( out_table, vector_ref(out_bar_reg, i));
              vcTable.Add( out_table, vector_ref(out_load_reg, i));
         }

         scrolled_region2 := vcTable.Scroll ("out", out_table, out_table,
                             1, 8, 10 );
    


         t_top := vcTable.Create ("constraints", 6, 1);
         vcTable.Add (t_top, stringbutton (list (list(
                      func(s) { load_cons_file = s; },
                      func() {load_cons_from_file(load_cons_file);},
                      "Load constraint file:", ""))));
         vcTable.Add (t_top, stringbutton (list (list(
                      func(s) { save_cons_file = s; },
                      func(){save_cons_to_file(save_cons_file);},
                      "Save constraint file:", ""))));

         vcTable.Add (t_top, flatregion ("Input constraints:",
                      func (s) { input_cons_type = s; update_arrive_table(
                      input_cons_type);} , input_cons_type, list (
                      list ("rise/fall", "rsfa"),
                      list ("rise", "rise"),
                      list ("fall", "fall"))));
         vcTable.Add (t_top, scrolled_region1 );

         vcTable.Add (t_top, vcWv.LabelButtonCreate ("clear",
                         "clear input arrival time", nil, call_clear_arrival,
                          list (macro_on <- TRUE)));

         vcTable.Add (t_top, flatregion ("Output constraints:",
                      func (s) { output_cons_type = s; update_require_table(
                      output_cons_type);}, output_cons_type, list (
                      list ("rise/fall", "rsfa"),
                      list ("rise", "rise"),
                      list ("fall", "fall"))));

         vcTable.Add (t_top, scrolled_region2 );

         vcTable.Add (t_top, vcWv.LabelButtonCreate ("clear",
                         "clear output required time", nil, call_clear_require,
                          list (macro_on <- TRUE)));

  
         /* create acceept, apply, cancel button */
         
         butlist := putwindow (cb_action, cb_cancel, t_top, "Constraints"
);




       } /* end of function create_cons_table */

       /* function for load new constraint file */

       function load_cons_from_file( filename ) {

          
            load_cons( filename );
            update_require_table( "rsfa" );
            update_arrive_table( "rsfa" );
            for (j:=0; j< in_no; ++j ) {
                stringregion_set( vector_ref(in_load_reg, j), vector_ref(in_load,j) );
                stringregion_set( vector_ref(in_drive_rise_reg, j), vector_ref(in_drive_rise,j) );
                stringregion_set( vector_ref(in_drive_fall_reg, j), vector_ref(in_drive_fall,j) );
            }
            for (j:=0; j< out_no; ++j )
                stringregion_set( vector_ref(out_load_reg, j), vector_ref(out_load,j));
             
       }

       function save_cons_to_file( filename ) {

             fp := fopen( filename, "w" );
             for (i := 0; i < in_no; ++i ) {
                if( !string_eq(vector_ref( in_arrive_rise, i), max_time ) 
                    && !string_eq(vector_ref( in_arrive_fall, i), max_time ))
                  fprintf( fp, "input_arrival %s %s %s\n",
                               vector_ref( in_arrive_rise, i),
                               vector_ref( in_arrive_fall, i),
                               vector_ref( in, i ));
                if( !string_eq(vector_ref( in_load, i), max_time )) 
                  fprintf( fp, "max_input_load %s %s\n",
                               vector_ref( in_load, i),
                               vector_ref( in, i ));
                if( !string_eq(vector_ref( in_drive_rise, i), max_time )
                    && !string_eq(vector_ref( in_drive_fall, i), max_time ))
                  fprintf( fp, "input_drive %s %s %s\n",
                               vector_ref( in_drive_rise, i),
                               vector_ref( in_drive_fall, i),
                               vector_ref( in, i ));
             }
              for (i := 0; i < out_no; ++i ) {
                if( !string_eq(vector_ref( out_require_rise, i), max_time )
                    && !string_eq(vector_ref( out_require_fall, i), max_time ))
                  fprintf( fp, "output_required %s %s %s\n",
                               vector_ref( out_require_rise, i),
                               vector_ref( out_require_fall, i),
                               vector_ref( out, i ));
                if( !string_eq(vector_ref( out_load, i), max_time ))
                  fprintf( fp, "output_load  %s %s\n",
                               vector_ref( out_load, i),
                               vector_ref( out, i ));
           }
           fclose( fp );
       }


       /* callback function for apply and accept */
       function cb_action() { 

         filename := cons_file; 
         save_cons_to_file( filename );
         vcShell.TypeIn( vdes_shell, "clean_cons", TRUE ); 
         vcShell.TypeIn( vdes_shell, "mex " + filename, TRUE ); 
      
       }
       function cb_cancel(doenable) { 
           if (doenable == TRUE) {
              vcCmd.Enable (constraint_cmd, vlOnOff.On);
           vcWin.UpdateMenus (vdes2_win); } 
       }

       /* main function to create constraint table */

       vcWin.Busy (vdes2_win, TRUE);
       vcCmd.Enable (constraint_cmd, vlOnOff.Off);
       vcWin.UpdateMenus (vdes2_win);
                                
       load_cons_file = "";
       save_cons_file = "";


       /* save current constraints into file. This way, we won't miss
          whatever typed in the shell window                          */
 
       vscript.vsDelete(scons_file, vscript.vsFILE );
       vcShell.TypeIn(vdes_shell,"save_constrain "+ cons_file, TRUE); 
       check_consfile( func() { 
           load_cons( cons_file );
           create_cons_table();
           vcWin.Busy (vdes2_win, FALSE);
       });


} /* end of call_set_constraint */
                               

function set_operating_points(d, e, module_name, library_name,
                               voltage, temperature,
                               pkg, logic, process)
 {
     new_package = convert( string, pkg );
     new_logic_type = convert( string, logic );
     new_process_type = convert( string, process );
     new_voltage = convert( float, voltage);
     new_temperature = convert( float, temperature);
     if( !string_eq(current_package, new_package ) &&
         !string_eq(new_package, empty_package )) {
          vcShell.TypeIn(vdes_shell, "package " + new_package, TRUE );
          current_package = new_package;
     }
     if( current_temperature != new_temperature ) {
          vcShell.TypeIn(vdes_shell, "temperature " + convert( string, 
                         new_temperature) , TRUE );
          current_temperature = new_temperature;
     }
     if( current_voltage != new_voltage ) {
          vcShell.TypeIn(vdes_shell, "voltage  " + convert( string, new_voltage)
                         , TRUE );
          current_voltage = new_voltage;
     }
     if( !string_eq(current_process_type, new_process_type )) {
          if( string_eq(new_process_type, "typical" ))
              vcShell.TypeIn(vdes_shell, "process " + "1" , TRUE);
          if( string_eq(new_process_type, "slow" ))
              vcShell.TypeIn(vdes_shell, "process " + "0" , TRUE);
          if( string_eq(new_process_type, "fast" ))
              vcShell.TypeIn(vdes_shell, "process " + "2" , TRUE);
          current_process_type = new_process_type;
     }
     if( !string_eq(current_logic_type, new_logic_type )) {
          vcShell.TypeIn(vdes_shell, "logic_type " + new_logic_type , TRUE);
          current_logic_type = new_logic_type;
     }
 }

function get_current_module( data ) 
     return( current_module );

function get_current_tech( data ) 
     return( current_tech );
 
function get_current_voltage( data ) 
     return( current_voltage );
 
function get_current_temperature( data ) 
     return( current_temperature );
 
function get_current_package( data ) 
     return( current_package );
 


 
alias_cmd := cmd ("alias", "alias",  "alias",
        list(vcWv.Param("alias [ a [b] ]", string, vcWv.Sticky, "")));
	vcCmd.EnableApply(alias_cmd, vlOnOff.On);

temperature_cmd := cmd ("temp", "temp", "temperature",
    list(vcWv.Param("temperature",string,  vcWv.Sticky, "25.0")));
    vcCmd.EnableApply(temperature_cmd, vlOnOff.On);
voltage_cmd := cmd ("volt", "volt", "voltage",
    list(vcWv.Param("voltage",string,  vcWv.Sticky, "5.0")));
    vcCmd.EnableApply(voltage_cmd, vlOnOff.On);

run_system_cmd := cmd ("%", "%", "%",
    list(vcWv.Param("Run program < program args >",string,  vcWv.Sticky, "")));
    vcCmd.EnableApply(run_system_cmd, vlOnOff.On);

set_alias_cmd := cmd ("set_alias", "alias", "alias",
    list(vcWv.Param("alias [ name ]",string,  vcWv.Sticky, ""),
         vcWv.Param("is defined as ",string,  vcWv.Sticky, "")));
    vcCmd.EnableApply(set_alias_cmd, vlOnOff.On);

remove_alias_cmd := cmd ("unalias", "unalias", "unalias",
    list(vcWv.Param("remove alias [ name1 name2 ... ]",string,vcWv.Sticky,"")));
    vcCmd.EnableApply(remove_alias_cmd, vlOnOff.On);

show_aliases_cmd := cmd("show_alias_cmd", "alias", nil, nil);

start_macro_cmd := cmd ("macro", "macro", "macro",
    list(vcWv.Param("recording macro filename", string,  vcWv.Sticky, "")));
    vcCmd.EnableApply(start_macro_cmd, vlOnOff.On);

close_macro_cmd := cmd ("close_macro", "mclose", nil, nil );

run_macro_cmd := cmd ("do_macro", "mex", "mex",
    list(vcWv.Param("execute macro filename", string,  vcWv.Sticky, "")));
    vcCmd.EnableApply(run_macro_cmd, vlOnOff.On);

clear_lib_cmd := cmd ("clear_lib", "clear_work_library", nil, nil);

list_lib_cmd := cmd ("list_lib", "list_work_library", nil, nil);

show_setup_cmd := cmd("show_setup_cmd", "setup", nil, nil);

show_history_cmd := cmd("show_history_cmd", "history", nil, nil);

version_cmd := cmd("version", "version", nil, nil);

viewgen_cmd := cmd("viewgen", "viewgen", nil, nil);

zero_max_delay_cmd := vcWv.Cmd( fac, call_max_delay_zero,"zero_max_delay_cmd");

/*
  * Define enumerated types needed to set operating points
  */
 vcWv.MakeEnum ("LogicVT", list ("default", "fsm", "large"));
 vcWv.MakeEnum ("ProcessVT", list ("slow", "typical", "fast"));

 set_points_cmd := vcWv.Cmd (fac, set_operating_points, "setpoints",
                             "Set Operating Points",
     vcWv.Param ("Module Name", string, vcWv.Dynamic, get_current_module, 
                  vcWv.Secondary,
                 "Module name read from analyze_vhdl command ",
                  read_only <- TRUE),
     vcWv.Param ("Library Name", string, vcWv.Dynamic, get_current_tech,
                  vcWv.Secondary, 
                 "technology library processed",
                   read_only <- TRUE),
     vcWv.Param ("Voltage", float, vcWv.Dynamic, get_current_voltage,
                 vcScalebar.fac, min <- 4, max <- 6, increment <- .1),
     vcWv.Param ("Temperature (C)", float, vcWv.Dynamic, get_current_temperature,
                 vcScalebar.fac,
                 "Number in degrees C", min <- -70, max <- 150),
     vcWv.Param ("Choices of packages", string, vcWv.Dynamic, get_current_package, 
                  p2.fac),
     vcWv.Param ("Logic Type", LogicVT, vcWv.Sticky, Logic.default),
     vcWv.Param ("Process Type", ProcessVT, vcWv.Sticky, Process.typical));

 vcCmd.EnableApply (set_points_cmd, TRUE);


function call_set_tech( d, e, tech ) {
   
   if( tech == "" ) {
       error("ERROR: Must specify library alias before applied");
   }
   pre_tech();
   vcShell.TypeIn (vdes_shell,"tech "+tech, TRUE);
   check_packfile( func() { post_tech( tech ); });
}
     
set_tech_cmd := vcWv.Cmd (fac, call_set_tech,"set_tech","specify target technology",
   vcWv.Param ("Technology", string, vcWv.Dynamic, get_current_tech, vdes3.fac));
vcCmd.EnableApply(set_tech_cmd, vlOnOff.On); 

function get_current_outdir( data ) 
     return( current_outdir );


function call_outdir( d, e , in ) {

    if( current_outdir == "" ) {
        error("ERROR: Must specify alias before applied");
    }
    current_outdir = in;
    vcShell.TypeIn (vdes_shell,"out_dir "+current_outdir, TRUE );
}     

outdir_cmd := vcWv.Cmd (fac, call_outdir, "outdir", "specify output directory by selecting an alias",
   vcWv.Param ("Out_dir alias", string, vcWv.Dynamic, get_current_outdir, vdes4.fac ));
vcCmd.EnableApply( outdir_cmd, vlOnOff.On);
  
function get_current_wire( data )
   return( current_outnet );

function call_wire( d, e, in1, in2 ) {

   current_outnet = in2;
   vcShell.TypeIn (vdes_shell,"wire "+ in1 + current_outnet, TRUE );
} 

wire_cmd := vcWv.Cmd (fac, call_wire, "wire_cmd", "specify output wire file",
   vcWv.Param ("Wire alias name", string, vcWv.Dynamic, get_current_outdir),
   vcWv.Param ("Wire file name", string, vcWv.Dynamic, get_current_wire));
vcCmd.EnableApply( wire_cmd, vlOnOff.On);

function get_current_report( data )
   return( current_report );

function call_report( d, e, in1, in2 ) {

   current_report = in2;
   vcShell.TypeIn (vdes_shell,"report "+ in1+ current_report, TRUE );
}

report_cmd := vcWv.Cmd (fac, call_report, "report_cmd", "specify report file",
   vcWv.Param ("Report alias name", string, vcWv.Dynamic, get_current_outdir),
   vcWv.Param ("Report file name", string, vcWv.Dynamic, get_current_report));
vcCmd.EnableApply( report_cmd, vlOnOff.On);


synth_cmd := vcWv.Cmd (fac, call_synth, "synth_cmd"  );

resynth_cmd := vcWv.Cmd( fac, call_resynth,"resynth_cmd" );

map_cmd := vcWv.Cmd( fac, call_map, "map_cmd" );

/* wire_cmd := vcWv.Cmd (fac, call_wire, "wire_cmd" ); */


show_report_cmd := vcWv.Cmd (fac, call_show_report, "show_report_cmd" );

constraint_cmd := vcWv.Cmd (fac, call_set_constraint, "constraint_cmd" );


/* main_menu */


m_run := vcWv.make_menu ("Run",
  list ("Synthesize", synth_cmd),
  list ("Resynthesize", resynth_cmd),
  list ("Map", map_cmd));

m_misc := vcWv.make_menu ("Command",
  list ("Run viewgen", viewgen_cmd),
  list ("Open macro...", start_macro_cmd),
  list ("Close macro", close_macro_cmd),
  list ("Run macro...", run_macro_cmd),
  list ("Show aliases", show_aliases_cmd),
  list ("Set alias...", set_alias_cmd),
  list ("Remove alias...", remove_alias_cmd),
  list ("Run system command", run_system_cmd),
  list ("Clear VHDL working library", clear_lib_cmd),
  list ("List VHDL working library", list_lib_cmd),
  list ("Show setup", show_setup_cmd),
  list ("Show history", show_history_cmd),
  list ("Show Version", version_cmd));


/* load viewscript files upon the product being invked */

if( string_ref(sec_code, 0) == string_ref(VHDLDES,0))
    load( "vdes2.vs");
else
    load( "retarg2.vs");


function _Size(region,size,region,wv)
{
    /* set the size of the window (ideal, minimum, maximum) */
    vcSize.Set(size,700,600,600,400,1000,1000);
}


function _Create( arg, region ) {

  function vdes_exit( mode, code ) {
   

    /* clear up cross-reference files */

    if( fexists( vdestmp_file )) vscript.vsDelete( vdestmp_file, vscript.vsFILE );
    if( fexists( pins_file )) vscript.vsDelete( pins_file, vscript.vsFILE );
    if( fexists( spins_file )) vscript.vsDelete( spins_file, vscript.vsFILE );
    if( fexists( pack_file )) vscript.vsDelete( pack_file, vscript.vsFILE );
    if( fexists( spack_file )) vscript.vsDelete( spack_file, vscript.vsFILE );
    if( fexists( cons_file )) vscript.vsDelete( cons_file, vscript.vsFILE );
    if( fexists( scons_file )) vscript.vsDelete( scons_file, vscript.vsFILE );
  
    /* print exiting message */

    if( code == 0 && mode == vcSysMode.Exited )  
        if( (mode == vcSysMode.Exited ) )  {
             print( "Program completed!!");
             vcWin.Destroy (vdes2_win);
        }
    if( code !=0 && mode == vcSysMode.Exited )
        close_all_commands(); 
     
  } /* end of vdes_exit */

     table := vcTable.Create("vdesII", 4, 1); 

    area_bar = vcRegion.Create1 ("foo", vcScalebar.fac,
                             /*
                              convert (vlPositiveIntVT, 1),
                             */
                              1.0,
                              list ( increment <- 1.0,
                                     min <- 1,
                                     max <- 100,

/* If the following value is vlOnOff.On, then a value field is displayed
   automatically. This value field represents the scroll bar; therefore,
   whenever you modify the value field, the scroll bar is modified too !!
                                     value <- vlOnOff.On    */
                                     value <- vlOnOff.On    
 
                                ));
    area_cmdline = vcRegion.Create1("area", vcCmdline.fac,
                                "       1", list(cons(`width,6)));

 
    vcScale.NotifyOnChange( area_bar, area_bar_changed );
 
    area_scale := vcTable.Create("area_scale", 1, 5);
    area_label := vcRegion.Create ("area", vcLabel.fac, "Area/Speed");
    vcTable.Add (area_scale, area_label);
    vcTable.Add (area_scale, area_bar );
    vcTable.Add (area_scale,
                 vcWv.LabelButtonCreate("Area/Speed", "Apply Area/Speed", nil, 
                            call_area_speed,  list (macro_on <- TRUE)));
    
   /*  End of defining the architecture block  */

   /*  Define the constraint block  */

    con_bar = logarithmic_scalebar( "bar",
                  max_time, 0, 1000, func(str) {
                  con_value = str;}); 


    con_label := vcRegion.Create ("delay", vcLabel.fac, "Max_delay");
    
    con_scale := vcTable.Create("con_scale", 1, 3);
    vcTable.Add(con_scale, con_label);
    vcTable.Add(con_scale, con_bar);

    vcTable.Add(con_scale,
                vcWv.LabelButtonCreate("max_delay", "apply max_delay", nil, 
                            call_max_delay, list (macro_on <- TRUE)));



    if( string_eq( VHDLDES, sec_code )) 
        vdes_shell = r :=  vcRegion.Create1 ("textreg", vcShell.fac, 
                                             "vhdldes -gui "+pins_file+
                                             " "+pack_file+" " + cons_file, nil);
    else 
        vdes_shell = r :=  vcRegion.Create1 ("textreg", vcShell.fac,
                                             "vhdldes -retarget -gui "+pins_file+
                                             " "+pack_file+" " + cons_file, nil); 
;

    sys = vcShell.Sys (vdes_shell);
 
    vcRegion.DestroyNotify (vdes_shell, func(r) vcSys.TypeIn (sys, "quit\n"););

    /* gui exits when the executables exits */

    vcSys.CallOnExit (sys, vdes_exit );

    vcTable.Add( table, area_scale );
    vcTable.Add( table, con_scale );
    vcTable.Add( table, r);
   vcRegion.AddChild (region, table);
   return (table);
 }

/* This last section creates the actual menu bar.  The call to vcWv.make_menu */
/* is the same, but it is followed by a call to vcFac.set_menus.  This        */
/* function takes two arguments, the mysterious "fac" and the name of a       */
/* menu you have already created.  This menu is the one that appears across   */
/* the top in your facility window.  Notice that the first entry is the red   */
/* square.                                                                    */
vcFac.SetMenus (fac, main_menu);
init_sfile();
init_menu();
