/*
 *  $Revision: 1.14 $
 *
 *  Viewscript UI definition for the Core vcGesture facility.
 *
 *  Copyright (c) 1992 by Viewlogic Systems, Inc.
 */

vcBind.Set (bindings, '\move', vcWv.Cmd (fac, Move));

CancelCmd := vcWv.Cmd (fac, Cancel, "CancelGesture");
vcCmd.EnableMacro (CancelCmd, vlOnOff.Off);
vcBind.Set (bindings, '\rightdown', CancelCmd);

FinishCmd := vcWv.Cmd (fac, Finish);
vcBind.Set (bindings, '\middleup', FinishCmd);
vcShowBind.SetGestureFinish (FinishCmd);

StartCmd := vcWv.Cmd (vcWin.fac,
                      func(window, event) {
                          r := vcEvent.Region (event);
                          g := vcFac.Gestures (vcRegion.Fac (r));
                          Start (g, event, vcRegion.Area (r), "cyan");
                      });
vcShowBind.SetGestureStart (StartCmd);

M := ["321 5 789",
      "321 565 789",
      "321 265 789",
      "321 568 789",
      "321 268 789",
      "321 4 789"];

C := ["7412369",
      "9632147"];
Z := ["147 5 369",
      "47  5 369",
      "147 5 36",
      "47  5 36"];
O := ["14789632",
      "47896321",
      "78963214",
      "89632147",
      "96321478",
      "63214789",
      "32147896",
      "21478963",

      "23698741",
      "36987412",
      "69874123",
      "98741236",
      "87412369",
      "74123698",
      "41236987",
      "12369874"];

P := ["321 47 852",
      "321 47 851"];
U := "123 6 987";
UpsideDownCheck := ["321478",
                    "325478"];
d := ["9636987",
      "85236587",
      "989636987"];
R := ["32147852589",
      "32147852369",
      "32147852569"];


LineNE := "357";
LineNW := "951";
LineSE := "159";
LineSW := "753";

Question := [" 147856",
             "2147856"];

Line := [LineNE, LineNW, LineSE, LineSW];
Default := "";

/*
 * *Backward* compatibility, so apps linked with old Core can use
 * the new Core viewscript files.
 */
start:=Start;
move:=Move;
cancel:=Cancel;
finish:=Finish;
set := Set;
