/*
 *
 *  Viewscript UI definitions for the Core vcRadioButton facility.
 *
 */

armed_bindings := vcBind.Create ();

arm_cmd := vcWv.Cmd (fac,
                     func (button, ev)
                     {
                         arm (button, ev);
                             r := vcEvent.Region (ev);
                             vcRegion.SetGrab (r, r);
                             vcRegion.SetBindings (r, armed_bindings);
                     }, "arm");

fire_cmd := vcWv.Cmd (fac,
                      func (button, ev)
                      {
                          r := vcEvent.Region (ev);
                          vcRegion.SetGrab (r, nil);
                          vcRegion.SetBindings (r, bindings);
                          if (inside (button, vcEvent.X (ev), vcEvent.Y (ev)))
                              fire (button, ev);
                          else
                              disarm (button, ev);
                      }, "fire");

fire_key_cmd := vcWv.Cmd (fac,
                      func (button, ev)
                      {
                          r := vcEvent.Region (ev);
                          vcRegion.SetGrab (r, nil);
                          fire (button, ev);
                      }, "fire_key");

move_cmd := vcWv.Cmd (fac,
                      func (button, ev)
                      {
                          if (inside (button, vcEvent.X (ev), vcEvent.Y (ev)))
                              arm (button, ev);
                          else
                              disarm (button, ev);
                      });

vcCmd.EnableMacro (arm_cmd, vlOnOff.Off);
vcCmd.EnableMacro (fire_key_cmd, vlOnOff.Off);
vcCmd.EnableMacro (fire_cmd, vlOnOff.Off);
vcCmd.EnableMacro (move_cmd, vlOnOff.Off);

vcBind.Set (bindings, '\leftdown',  arm_cmd);
vcBind.Set (bindings, '\rightdown', arm_cmd);
vcBind.Set (bindings, ' ', fire_key_cmd);

vcBind.Set (armed_bindings, '\leftup',  fire_cmd);
vcBind.Set (armed_bindings, '\rightup', fire_cmd);
vcBind.Set (armed_bindings, '\move',    move_cmd);

vcWv.Interrupts (fac, '\leftup', '\rightup');

/*activate_cmd := vcWv.Cmd (fac, _Activate);*/
/*vcBind.set (bindings, ' ', activate_cmd);*/       /* KSelect, virtually */
