function init_menu() {
    vcCmd.Enable (analyze_vhdl_cmd,            vlOnOff.On);
    vcCmd.Enable (set_tech_cmd,            vlOnOff.On);
    vcCmd.Enable (synth_cmd,            vlOnOff.Off);
    vcCmd.Enable (resynth_cmd,            vlOnOff.Off);
    vcCmd.Enable (outdir_cmd,            vlOnOff.Off);
    vcCmd.Enable (wire_cmd,            vlOnOff.Off);
    vcCmd.Enable (report_cmd,            vlOnOff.Off);
    vcCmd.Enable (show_report_cmd,            vlOnOff.Off);
    vcCmd.Enable (map_cmd,            vlOnOff.Off);
    vcCmd.Enable (constraint_cmd,     vlOnOff.Off );
    vcCmd.Enable (set_points_cmd,        vlOnOff.Off);
} /* end of init_menu */

function close_all_commands() {

    vcCmd.Enable (analyze_vhdl_cmd,            vlOnOff.Off);
    vcCmd.Enable (set_tech_cmd,            vlOnOff.Off);
    vcCmd.Enable (synth_cmd,            vlOnOff.Off);
    vcCmd.Enable (resynth_cmd,            vlOnOff.Off);
    vcCmd.Enable (wire_cmd,            vlOnOff.Off);
    vcCmd.Enable (outdir_cmd,            vlOnOff.Off);
    vcCmd.Enable (report_cmd,            vlOnOff.Off);
    vcCmd.Enable (show_report_cmd,            vlOnOff.Off);
    vcCmd.Enable (map_cmd,            vlOnOff.Off);
    vcCmd.Enable (constraint_cmd,     vlOnOff.Off );
    vcCmd.Enable (set_points_cmd,        vlOnOff.Off);
    vcCmd.Enable (viewgen_cmd,        vlOnOff.Off);
    vcCmd.Enable (start_macro_cmd,        vlOnOff.Off);
    vcCmd.Enable (close_macro_cmd,        vlOnOff.Off);
    vcCmd.Enable (run_macro_cmd,        vlOnOff.Off);
    vcCmd.Enable (show_aliases_cmd,        vlOnOff.Off);
    vcCmd.Enable (set_alias_cmd,        vlOnOff.Off);
    vcCmd.Enable (remove_alias_cmd,        vlOnOff.Off);
    vcCmd.Enable (run_system_cmd,        vlOnOff.Off);
    vcCmd.Enable (clear_lib_cmd,        vlOnOff.Off);
    vcCmd.Enable (list_lib_cmd,        vlOnOff.Off);
    vcCmd.Enable (show_setup_cmd,        vlOnOff.Off);
    vcCmd.Enable (show_history_cmd,        vlOnOff.Off);
    vcCmd.Enable (version_cmd,        vlOnOff.Off);
    vcWin.UpdateMenus (vdes2_win);
}

function call_vhdm( filename ) {
        if ((filename != nil) && ( string_ref(filename, string_length(filename)-2) != '/')
             && !string_eq(filename, " ")) {
            current_design = filename;
            vscript.vsDelete( spins_file, vscript.vsFILE );
            vcShell.TypeIn (vdes_shell, "vh "+ current_design, TRUE);
            vcCmd.Enable (constraint_cmd, vlOnOff.Off);
            vcWin.UpdateMenus (vdes2_win);
            for( i := 0; i < 100; ++i );
            readpins( func() {
                vcCmd.Enable (analyze_vhdl_cmd, vlOnOff.On);
                enable_syn();
                vcCmd.Enable (constraint_cmd, vlOnOff.On );
                vcWin.UpdateMenus (vdes2_win); });
        }
        else {
            vcWin.AddStatus(vdes2_win, "** Please select a VHDL file **\n");
        }
}

function call_analyze_vhdl( d, e, filename)
{

   /*  Define VHDL block   */

      filename = convert( string, filename );
      if( string_eq(filename, "")) {
          CallEcho("VHDLDES: Must specify filename before analyze  vhdl\n");
      }
      current_design = filename;
      call_vhdm( current_design );
}

analyze_vhdl_cmd := vcWv.Cmd (fac, call_analyze_vhdl,"analyze_vhdl_cmd",
                    "analyze_vhdl_cmd",
                    vcWv.Param("VHDL filename", vlFileNameVT, vcWv.Sticky,
                                  " ",
                               filter <- "*.vhd"));
vcCmd.EnableApply(analyze_vhdl_cmd, vlOnOff.On);

main_menu := vcWv.make_menu  ("main_menu",
  vcWin.RedSquareEntry,
  list ("Set technology", set_tech_cmd),
  list ("Analyze VHDL", analyze_vhdl_cmd),
  list ("Run", m_run),
  list ("Set out_dir", outdir_cmd),
  list ("Wire", wire_cmd),
  list ("Report", report_cmd),
  list ("Constraints", constraint_cmd),
  list ("Operating points", set_points_cmd),
  list ("Misc", m_misc));

