/*
 * Run ViewDRC's GUI from the cockpit
 */

if (!isbound (`vdrc, current_package ())) {
    vcFac.Create ("vdrc", vscmVT);
    function run_drc(data, event, design)
        vcWin.Create (vcRegion.Create ("DRC " + design, vdrc.fac, design));

    function design_default(vf) {
        design := getenv ("WDESIGN");
        if (design == nil)
            "";
        else
            design;
    } /* function design_default */

    drc_cmd := vcWv.Cmd (vframe.fac, run_drc, "drc",
                         "Invoke ViewDRC on Design",
                         vcWv.Param ("Design", vlStringVT, vcWv.Dynamic,
                                     design_default));
    vcCmd.SetHelp (drc_cmd, "Invoke the Online Design Rule Checker");

    function vdrcRun() {
        /* Find a window, preferably the viewframe window */
        window := nil;
        region := nil;
        foreach (w; vcWin.Loop ()) {
            window = w;
            region = vcWin.OwnerRegion (w);
            if (vcRegion.Fac (region) == vframe.fac)
                break;
        } /* foreach */

        if (window != nil) {
            event := vcEvent.Create (0, 0, '0', "", window, region, nil);
            vcCmd.Run (drc_cmd, window, event, nil, TRUE);
        } /* if */
    } /* function vdrcRun */
} /* if */

vdrcRun ();
