/*
 * $Revision: 1.6 $
 */

/* Implements the handshaking picklist */

package vsphshk (create_hshklist, apply_changes) {

declare hs_reg;

/* The following are alists associating a label with internal rep. of value
 */

hslst := list (cons ("Hardwire", "HS_HARDWARE"), 
                cons ("VHardwire", "HS_VHARDWARE"),
                cons ("XON/XOFF", "HS_XON_XOFF"),
                cons ("ENQ/ACK", "HS_ENQ_ACK"),
                cons ("None", "HS_NONE"));

/* This corresponds to position in above list
 */
vspHS_NONE := 4;

vspHS := "HANDSHAKE";

cur_hshk := "HS_NONE";

declare hs_array;

/* Called when user selects a new handshake.
 */
function set_hshk (val, on_off) {

        if (on_off == vlOnOff.Off)
                return (nil);

        vspoptns.set_options_modified();
        cur_hshk = val;
}

handshakes := list (0, `vertical, "HANDSHAKING", hslst, set_hshk);

function get_hs_index (val) {

        for (tlst := hslst, i := 0; tlst != nil; tlst = cdr(tlst), ++i) {
                if (string_eqi(val, cdr(car(tlst))))
                        return (i);
        }

        /* If don't match anything, return HS_NONE */
        return (vspHS_NONE);
}

/* Called when user hits "apply" button on options worksheet
 */
function apply_changes () {
        if (vcRegion.IsEnabled (hs_reg))
                fac_pack.sp_sapopt (string_append(vspHS, " ", cur_hshk));
}

/* Called when building options worksheet
 */
function create_hshklist () {

        /* Set the default */
        index := get_hs_index(fac_pack.get_def_hs ());
        set_car (handshakes, index);

        /* Create a picklist for handshakes */
        hs_reg = create_pklst (func () return (get_hs_index(
                        fac_pack.get_def_hs ()));,
                        cadr(handshakes), caddr(handshakes), 
                        cadddr(handshakes), cadr(cdddr(handshakes)), FALSE);

        if (!fac_pack.hs_applicable ())
                vcRegion.Enable (hs_reg, FALSE, TRUE);

        for (i := 0,tlst := hslst; i < index; ++i)
                tlst = cdr (tlst);

        cur_hshk = cdr(car(tlst));

        return(hs_reg);
}        
}        









