/* $Revision: 1.10 $
 * Implementation for the middle column of the Plot Options Worksheet
 */

package vspoptmc (create_middle_col, apply_changes) {

declare cur_outdir;
declare cur_initstr;
declare cur_termstr;
declare odir_cmdline, cur_ovly_val, wproj_odir_lab, spec_odir_lab, odir_ovly,
        cur_wproj_odir;
declare init_str_cmdline, term_str_cmdline;

function apply_changes () {

        ret1 := TRUE;

/*        if (string_eqi (fac_pack.get_def_output_type (), "file")) { */
                cur_outdir = vcRegion.Get (odir_cmdline, string);
                ret1 = fac_pack.sp_sapopt (string_append("OUTDIR ", 
                                                cur_outdir));

                if (!string_eqi (cur_outdir, "none"))
                        vspport.update_output_cmdline (cur_outdir);
                else
                        vspport.update_output_cmdline (".");

        if (cur_wproj_odir)
            fac_pack.sp_sapopt ("WPROJ_ODIR TRUE");
        else
            fac_pack.sp_sapopt ("WPROJ_ODIR FALSE");
/*
        }
 */

        ret2 := fac_pack.sp_sapopt (string_append("INIT ", 
                                    vcRegion.Get (init_str_cmdline, string)));

        ret3 := fac_pack.sp_sapopt (string_append("TERM ", 
                                    vcRegion.Get (term_str_cmdline, string)));

        return (ret1 && ret2 && ret3);
}

/* Saves the value for output directory and sets the modified flag so that
 * the value will be set in the software if and when the apply button is hit
 */
function set_outdir (data, val) {
        set_options_modified ();
        cur_outdir = val;

        cur_ovly_val = spec_odir_lab;
        cur_wproj_odir = FALSE;
        vcOverlay.SetCurrent (odir_ovly, spec_odir_lab);
}

/* Saves the value for Init. String and sets the modified flag so that
 * the value will be set in the software if and when the apply button is hit
 */
function set_initstr (data, val) {
        set_options_modified ();
        cur_initstr = val;
}

/* Saves the value for Term. String and sets the modified flag so that
 * the value will be set in the software if and when the apply button is hit
 */
function set_termstr (data, val) {
        set_options_modified ();
        cur_termstr = val;
}

function switch_ovly () {
        if (cur_ovly_val == wproj_odir_lab) {
                vcOverlay.SetCurrent (odir_ovly, spec_odir_lab);
                cur_ovly_val = spec_odir_lab;
        }
        else {
                vcOverlay.SetCurrent (odir_ovly, wproj_odir_lab);
                cur_ovly_val = wproj_odir_lab;
        }
}

function hit_ovly_button () {
        set_options_modified ();
        switch_ovly ();
        if (cur_ovly_val == wproj_odir_lab) {
             wproj := vscript.getenv ("WPROJECT");
             if (wproj == nil)
                cur_outdir = ".";
             else
                cur_outdir = wproj;
             vcCmdline.Set (odir_cmdline, cur_outdir);
             cur_wproj_odir = TRUE;
        }
        else
             cur_wproj_odir = FALSE;
}
                
/* Create the 'use wproject or not' overlay button and outdir command line
 */
function create_outdir_row () {

        odir_cmdline_list := create_cmdline ("Out Directory> ", 
                fac_pack.get_def_outdir(), set_outdir, TRUE, 10, 15);
        odir_cmdline = car (odir_cmdline_list);

        wproj_odir_lab = vcLabel.ButtonCreate ("wproj_odir.but","WPROJECT",
                hit_ovly_button, list (macro_on <- FALSE));
        spec_odir_lab = vcLabel.ButtonCreate ("spec_odir.but","Specified",
                hit_ovly_button, list (macro_on <- FALSE));

        odir_ovly = vcRegion.Create1 ("wproj.ovly", vcOverlay.fac,
                vgAlign.LowerLeft, nil);

        vcRegion.AddChild (odir_ovly, wproj_odir_lab);
        vcRegion.AddChild (odir_ovly, spec_odir_lab);

        cur_wproj_odir = fac_pack.GetOdirDef ();
        if (cur_wproj_odir) {
            cur_ovly_val = wproj_odir_lab;
            vcOverlay.SetCurrent (odir_ovly, wproj_odir_lab);
        }
        else {
            cur_ovly_val = spec_odir_lab;
            vcOverlay.SetCurrent (odir_ovly, spec_odir_lab);
        }

        ttab := vcTable.Create ("Odir_area", 1, 2);
        vcTable.Add (ttab, odir_ovly);
        vcTable.Add (ttab, cadr (odir_cmdline_list));

        return (vcRegion.Create1("odir_area.border", vcBorder.fac, ttab, nil));
}

/* Creates the middle column of the Plot Options Worksheet.
 */
function create_middle_col () {
        
        /* Create the Table to hold the widgets of the middle column */
        mid_col := vcTable.Create("Opt_mid_col", 5, 1);
        vcTable.Col (mid_col, -1, vcTable.Border.Invisible,
                        2, 4, 6, vgAlign.LowerLeft);

        /* Get default values for all widgets in column */
        cur_outdir = fac_pack.get_def_outdir ();
        cur_termstr = fac_pack.get_def_termstr ();
        cur_initstr = fac_pack.get_def_initstr ();

        /* Create and Add the "OUTDIR" input area */
        vcTable.Add (mid_col, create_outdir_row ());
                
        /* Create and Add the INITSTRING command line */
        init_str_cmdline_list := create_cmdline ("Init. String> ", 
                fac_pack.get_def_initstr(), set_initstr, TRUE, 10, 15);
        init_str_cmdline = car (init_str_cmdline_list);
        vcTable.Add (mid_col, cadr (init_str_cmdline_list));

        /* Create and Add the TERMSTRING command line */
        term_str_cmdline_list := create_cmdline ("Term. String> ", 
                fac_pack.get_def_termstr(), set_termstr, TRUE, 10, 15);
        term_str_cmdline = car (term_str_cmdline_list);
        vcTable.Add (mid_col, cadr (term_str_cmdline_list));

        return (mid_col);
}
                
}
