/* $Revision: 1.5 $
 * Implements the Plot Options worksheet.  All changes are temporarily stored
 * in Viewscript until the 'Apply' button is hit.
 */

package vspoptns (create_options_wksht, set_options_modified) {

/* Load all constituent widgets for options worksheet */
load("vspoptlc.vs");
/* This is for the middle column (thus the 'mc' in the name) */
load("vspoptmc.vs");
/* This is for the zsize definition area */
load("vspzsize.vs");

declare options_win_id;

declare vspOptionsTable;

tab_width := 3;
tab_height := 2;
options_modified := FALSE;

OptionsWkshtTitle := "Plot Options Worksheet";

function set_options_modified () {
        options_modified = TRUE;
}

/* Calls all of the options worksheet's constituent member's apply_changes
 * routine so that the software is updated.
 */
function update_options_changes () {
        vspoptlc.apply_changes ();
        ret1 := vspoptmc.apply_changes ();
        ret2 := vspoptrc.apply_changes ();
        return (ret1 && ret2);
}

/* Apply all the changes and close the worksheet
 */
function apply_n_close_options () {
/*
        if (options_modified) {
 */
                /* Only close worksheet if all entries are ok */
                if (update_options_changes ())
                        options_win_id = window_close (options_win_id);
/*
        }
        else
                options_win_id = window_close (options_win_id);
 */
}

/* Discard all changes and close the worksheet
 */
function cancel_n_close_options (close_options_wksht) {

        if (close_options_wksht)
                options_win_id = window_close (options_win_id);
}

/* This is the function which actually builds the options worksheet.
 */
function create_options_wksht () {

        major_tab := vcTable.Create (OptionsWkshtTitle, 2, 1);

        /* Create a table containing all plot options worksheet widgets */
        vspOptionsTable = vcTable.Create("options.tab", tab_height,
                                tab_width);

        /* Add left column to options table */
        vcTable.Add (vspOptionsTable, vspoptlc.create_left_col ());

        /* Add middle column */
        vcTable.Add (vspOptionsTable, vspoptmc.create_middle_col ());

        /* Add right column */
        vcTable.Add (vspOptionsTable, vspoptrc.create_right_col ());

        ttab := vcTable.Create ("acc_can.tab", 1, 2);
        /* Add the 'Accept' and 'Cancel' buttons */
        add_but (ttab,  vspACCEPT, 0, 0, 
                func () apply_n_close_options (););
        add_but (ttab, vspCANCEL, 0, 1,
                func () cancel_n_close_options (TRUE););

        vcTable.Add (major_tab, vspOptionsTable);
        vcTable.Add (major_tab, ttab);
        options_win_id = vcWin.Create (major_tab, 5);

        /* Forward all events to options worksheet */
        vcWin.Forward (plot_win_id, options_win_id);
}


}

