/*
 *  $Revision: 1.5.4.1 $
 *
 *  Viewscript UI definitions for the Core vcScalebar facility.
 *
 *  Copyright (c) 1992 by Viewlogic Systems, Inc.
 */

set := Set;                     /* Upward compatibility */

/*\vscmuserDocpage vcScalebar.CallOnChange -- set up a notification

DESCRIPTION
     Sets up a routine that is called every time a change is made to the
     slider, and the string can be parsed as a floating point number.
     The routine is called as follows:

         proc (val_str)
             vlStringVT val_str;

     where the val_str is the string value currently displayed in the
     command line next to the sliding bar.

NOTE
     vcScalebar.CallOnChangeFloat delivers the numeric value
     directly, rather than as a string, and may make more sense
     to call than this routine.

SYNOPSIS
     vcScalebar.CallOnChange(scalebar, proc)
         vcRegionVT scalebar;
         closureVT  proc;
*/
function CallOnChange(scalebar_region, proc)
    CallOnChangeFloat (scalebar_region,
                       func(val) proc (convert (vlStringVT, val)););
                   
