;;;;
;;;; $Revision: 1.34.2.10 $  $Date    : 93/12/18 16:44:43 $
;;;;
;;;; Master Class Definition file for Viewlogic tools.
;;;;
;;;; Copyright (c) 1994,1995 by Viewlogic Systems, Inc.
;;;;



(vdm|ClassFileSetVersion class_file 2.0)



;;;
;;; Load the default object editors.
;;;
(load "vdmEdit" nil)



;;;
;;; ViewDraw schematic sheet.
;;;
(vdm|ClassCreate "Schematic" class_file
     `(AttrList         . ("BLOCK" "SHEET"))
     `(AttrFilter       . ("[0-9a-zA-Z_]+" "[0-9]+"))
     `(Editor           . ,vdmEditViewDraw)
     `(NameTemplate     . "$BLOCK.$SHEET");
     `(PhysicalTemplate . "sch/$BLOCK.$SHEET")
     `(Type             . ,vdmClassType|File))



;;;
;;; ViewDraw symbol.
;;;
(vdm|ClassCreate "Symbol" class_file
     `(AttrList         . ("BLOCK" "SHEET"))
     `(AttrFilter       . ("[0-9a-zA-Z_]+" "[0-9]+"))
     `(Editor           . ,vdmEditViewDraw)
     `(NameTemplate     . "$BLOCK.$SHEET");
     `(PhysicalTemplate . "sym/$BLOCK.$SHEET")
     `(Type             . ,vdmClassType|File))



;;;
;;; ViewDraw Occurence Attribute file.
;;;
(vdm|ClassCreate "OATs" class_file
     `(AttrList         . ("BLOCK"))
     `(AttrFilter       . ("[0-9a-zA-Z_]+"))
     `(NameTemplate     . "$BLOCK");
     `(PhysicalTemplate . "sch/$BLOCK.oat")
     `(Type             . ,vdmClassType|File))



;;;
;;; ViewDraw wir file.
;;;
(vdm|ClassCreate "Wir" class_file
     `(AttrList         . ("BLOCK" "SHEET"))
     `(AttrFilter       . ("[0-9a-zA-Z_]+" "[0-9]+"))
     `(Editor           . ,vdmEditDefault)
     `(NameTemplate     . "$BLOCK.$SHEET");
     `(PhysicalTemplate . "wir/$BLOCK.$SHEET")
     `(Type             . ,vdmClassType|File))



;;;
;;; Mega files
;;;
(vdm|ClassCreate "Megafile" class_file
     `(AttrList         . ("NAME"))
     `(AttrFilter       . (".*\\.(tbl|lib)"))
     `(Editor           . ,vdmEditMegafile)
     `(NameTemplate     . "$NAME");
     `(PhysicalTemplate . "$NAME")
     `(Type             . ,vdmClassType|File))


;;;
;;; Meta-data object.  It's used internally by the VDM to store data
;;; about the data objects.
;;;
(vdm|ClassCreate "vdmMetaData" class_file
     `(AttrList         . ("NAME"))
     `(AttrFilter       . (".*"))
     `(PhysicalTemplate . "$NAME"))


;;;
;;; Widlcard  class.
;;;
(vdm|ClassCreate "vdmWildcard" class_file
     `(AttrList         . ("NAME"))
     `(AttrFilter       . (".*"))
     `(PhysicalTemplate . "$NAME")
     `(Type             . ,vdmClassType|Abstract))


;;;
;;; Configuration object. Used internally by the VDM to create configurations.
;;;
(vdm|ClassCreate "vdmCollection" class_file
     `(AttrList          . ("NAME"))
     `(AttrFilter        . (".*"))
     `(CollectionMembers . ("vdmWildcard"))
     `(NameTemplate      . "$NAME")
     `(PhysicalTemplate  . "vdmfcoll/$NAME.vcl")
     `(Type              . ,vdmClassType|Composite))



;;;
;;; Generic file class.
;;;
(vdm|ClassCreate "AnyFileOrDir" class_file
     `(AttrList         . ("NAME"))
     `(AttrFilter       . (".*"))
     `(Editor           . ,vdmEditDefault)
     `(PhysicalTemplate . "$NAME")
     `(Type             . ,vdmClassType|File))


;;;
;;; vflFlow class
;;;
(vdm|ClassCreate "vflFlow" class_file
     `(AttrList         . ("NAME"))
     `(AttrFilter       . (".*"))
     `(Editor           . ,vflFlow_edit)
     `(PhysicalTemplate . "$NAME.vfl")
     `(Type             . ,vdmClassType|File))


;;;
;;; Verilog file.  Note that there's really no enforcable standard
;;; specifying how a Verilog source file should be named.  This
;;; definition follows the convention of using either the .v or .V
;;; extension.
;;;
(vdm|ClassCreate "Verilog Source" class_file
     `(AttrList         . ("FILENAME" "EXT"))
     `(AttrFilter       . (".*" "[vV]"))
     `(Editor           . "$EDITOR")
     `(NameTemplate     . "$FILENAME")
     `(PhysicalTemplate . "$FILENAME.$EXT")
     `(Type             . ,vdmClassType|File))



;;;
;;; VHDL file.  Note that there's really no enforcable standard
;;; specifying how a VHDL source file should be named.  This
;;; definition follows the convention of using either the .vhd
;;;
(vdm|ClassCreate "VHDL" class_file
     `(AttrList         . ("NAME"))
     `(AttrFilter       . (".*"))
     `(Editor           . ,vdmEditDefault)
     `(NameTemplate     . "$NAME")
     `(PhysicalTemplate . "$NAME.vhd")
     `(Type             . ,vdmClassType|File))


;;;
;;; ViewFSM data.
;;;
(vdm|ClassCreate "StateMachine" class_file
     `(AttrList         . ("BLOCK" "SHEET"))
     `(AttrFilter       . ("[0-9a-zA-Z_]+" "[0-9]+"))
     `(Editor           . ,vdmEditViewFSM)
     `(NameTemplate     . "$BLOCK.$SHEET");
     `(PhysicalTemplate . "vst_sch/$BLOCK.$SHEET")
     `(Type             . ,vdmClassType|File))
