/*
 * $Id: vflEdit.vs,v 1.1.1.1 1995/04/13 17:42:36 akoren Stab $
 *
 * The editor function for vflFlow types.
 *
 * This function switches to the flow, if a vflow region is currently
 * available. Otherwise, it kicks off a viewflow process
 */

function vflFlow_edit(obj, output, error, exit) {
    /* first look for a vflow region in our executable */
    declare vflow_rgn;
    if (isbound (`vflow, nil))
        foreach (w; vcWin.Loop ())
            if (vflow_rgn == nil)
                vflow_rgn = vcRegion.FindFac (vcWin.OwnerRegion (w), 
                                              vflow.fac);

    if (vflow_rgn == nil)
        vcSys.Command ("viewflow -mode edit " + vdm.ObjGetName (obj),
                        nil, output, error, exit, nil);
    else {
        /* this part here assumes that the vflow facility is defined */
        catch (vlEx.FAILURE) {
            ev := vcEvent.Create (0, 0, ' ', nil, 
                        vcRegion.Window (vflow_rgn), vflow_rgn, nil);
            vcCmd.Run (vflow.OpenCmd, vcRegion.GetData (vflow_rgn),
                          ev, list (vdm.ObjGetName (obj),
                     vpm.LocationGetAlias (vdm.ObjGetLocation (obj)), 
                                 vflowMode.Edit), FALSE);
            exit (vcSysMode.Exited, 0);
        } exception {
            vlErr.Out (nil, vlErr.CurrentError ());
            exit (vcSysMode.Signalled, 0);
        }
    }
}
