/*
 * $Id: vflInfo.vs,v 1.6.1.3 1995/04/20 21:06:36 akoren Exp $
 *
 * The information text area of a viewflow screen.
 */

DataNames := vtxHighlight.Keyword1;
TaskNames := vtxHighlight.Keyword2;
Symbols := vtxHighlight.Keyword3;
RedMsg  := vtxHighlight.Regexp1;
RunningMsg := vtxHighlight.Keyword4;
CompletedMsg := vtxHighlight.Keyword5;

/* this pref data base should already exist */
p := vlPref.Create ("vflowcolor");
vtx.RegisterHighlight ("vfl", nil, vtxHighlight.CaseSensitive,
         list (list (DataNames, vlPref.Val (p, "data_names"), ""),
               list (TaskNames, vlPref.Val (p, "task_names"), ""),
               list (Symbols, vlPref.Val (p, "global_syms"), ""),
               list (RedMsg, vlPref.Val (p, "failed"), "`.*'"),
               list (RunningMsg, vlPref.Val (p, "running"), "Running"),
               list (CompletedMsg, vlPref.Val (p, "completed"), "Completed"),
               list (vtxHighlight.Delimiter, vgColor.Black, "{}.,?!()")));
HighlightPrefs := vlPref.Create ("vtx_vfl");

function _Create (unused, rgn) {

    info := struct {fname; vtx; rgn};
    u := "vflow999";
    info.fname = u + ".vfl";
    info.vtx = vcRegion.Create ("", vtx.fac, info.fname, 
                         highlight_keywords <- TRUE,
                         scratch <- TRUE,
                         height <- 10, width <- 40);
    info.rgn = rgn;
    vtx.ReadOnly (info.vtx, TRUE);
    vcRegion.AddChild (rgn, info.vtx);
    info;
}

function list_to_string(l) {
    str := "";
    foreach (elem; vscript.iter (l))
        str = str + elem + " ";
    str;
}
function SetNames (rgn, data, task, symbols) {
    info := vcRegion.GetData (rgn);
    vlPref.Setval (HighlightPrefs, "Keyword1", list_to_string (data));
    vlPref.Setval (HighlightPrefs, "Keyword2", list_to_string (task));
    vlPref.Setval (HighlightPrefs, "Keyword3", list_to_string (symbols));
    buf := vtx.GetBuffer (info.vtx);
    col := vtx.CurrentCol (info.vtx);
    line := vtx.CurrentLine (info.vtx);
    vtx.ReadOnly (info.vtx, FALSE);
    vtx.Load (info.vtx, info.fname);
    /* the extra space helps prevent garbage from going into an empty
     * vtx. Looks like a vtx bug, but for now...
     */    
    vtx.InsertString (info.vtx, buf + " ");
    vtx.Move (info.vtx, line, col);
    vtx.ReadOnly (info.vtx, TRUE);

    vcRegion.QueueForRefresh (info.vtx);
}

function AddLine (r, str) {
    info := vcRegion.GetData (r);
    vtx.ReadOnly (info.vtx, FALSE);
    vtx.AppendString (info.vtx, str);
    vtx.BeginningOfBuffer (info.vtx);
    vtx.ReadOnly (info.vtx, TRUE);
    vcRegion.QueueForRefresh (info.vtx);
}

function Clear (r) {
    info := vcRegion.GetData (r);
    vtx.ReadOnly (info.vtx, FALSE);
    vtx.Clear (info.vtx);
    vtx.ReadOnly (info.vtx, TRUE);
    vcRegion.QueueForRefresh (info.vtx);
}
if (FALSE) {
function _QueryDrop (info, ev, data, onoff) {
    /* I should be checking the data here */
    if (onoff)
         color := vgColor.Red;
    else
        color := vgAllColor.Background;

    vcRegion.Background (info.vtx, color, FALSE);
    vcRegion.QueueForRefresh (info.rgn);
    vcWvDropAccept.YesAll;
}

function _CompleteDrop (info, ev, data)
    print (data);    

}


