/*
 * $Revision: 1.1.1.1 $
 *
 * Subflow symbol editor
 */


function _Create (str, rgn) {
    stxt := vcRegion.Create ("", vcStaticText.fac, str);
    border := vcRegion.Create ("", vcBorder.fac, stxt);
    b := vcRegion.Create ("", vcButton.fac, PopupVtxCmd);
    vcRegion.AddChild (b, border);
    vcButton.HighlightRegion (b, border);
    vcRegion.AddChild (rgn, b);
    struct {
        txt = str;
        txt_rgn = stxt;
        vtx_rgn = nil
    };
}

function set_txt(ss, new) {
    ss.txt = new;
    vcStaticText.Clear (ss.txt_rgn);
    vcStaticText.Add (ss.txt_rgn, new);
}
function Set(rgn, new)
    set_txt (vcRegion.GetData (rgn), new);

function _Get(ss, rgn, ts)
    ss.txt;

function modify(ss, ev) {
    set_txt (ss, vtx.GetBuffer (ss.vtx_rgn));
    vcWin.Destroy (vcRegion.Window (ss.vtx_rgn));
}
ModifyCmd := vcWv.Cmd (fac, modify);
    
function popup_vtx(ss, ev) {
    vt := vcRegion.Create ("Edit Symbols", vtx.fac, "", scratch <- TRUE,
                                                        height <- 8,
                                                        width <- 25);
    ss.vtx_rgn = vt;
    vtx.AppendString (vt, ss.txt);
    parent := vcEvent.Window (ev);

    brow := vcRegion.Create ("", vcButnRow.fac, 
                list (list ("", "Accept", ModifyCmd, nil),
                      list ("", "Cancel", func(ev)nil;, 
                                         list (close_window <- TRUE))));
    t := vcTable.Make ("Edit Global Symbols", 2, 1, vt, brow);
    w := vcWin.Create (parent, t, vcWin.NoMenus + vcWin.NoStatus +
                                                  vcWin.NoCmdline);
    vcWin.Forward (parent, w);
}
PopupVtxCmd := vcWv.Cmd (fac, popup_vtx);


