/*
 * $RCSfile: vdbForm.vs,v $ $Revision: 1.59 $
 *
 * ViewDatabook II -- the vdbForm facility
 */


/*
 * Preferences come first, since their values define later behavior.
 */

/*
 * Added to support Edit/Fetching of links. Norm Sozio 5/5/95.
 */
vlPref.Replace (prefs, "enable_fetch", vlYesNoVT,
    "Enable the Fetch Button for links in the candidate dialog box", "No");
vlPref.Replace (prefs, "fetch_func", vscmVT, "~~fetch function for links",
                nil);

/*
 * This is a hook for substituting which function gets executed when the 
 * Fetch button is pressed for a link. Default is vdm.ObjCheckoutNoLock, but
 * this does not necessarily to a copy to the local area. Usrs can modify the 
 * behavior of Fetch by writng their own Viewscript function and registering 
 * it using this function.
 */
function SetFetchFunc(ffunc)
    if (!null(ffunc) && isprocedure(ffunc))
        vlPref.Setval (prefs, "fetch_func", ffunc);

/*
 *  Returns the appropriate function to execute on fetch. vdm.CheckoutNoLock
 *  is the default, but users can write their own function which takes a vdm
 *  object as the only parameter in the vdbus.vs file and register it with
 *  SetFetchFunc ( see above ).
 */
function FetchFunc()
    if (!null(fetch_func := vlPref.Val (prefs, "fetch_func")))
        fetch_func;
    else
        vdm.ObjCheckoutNoLock;

/*
 * Get Value of the enable_fetch preference
 */
function FetchEnabled()
    vlPref.Val (prefs, "enable_fetch") == vlYesNo.Yes;

/*
vlPref.Replace (prefs, "search_on_focus_change", vlYesNoVT,
    "execute search when focus leaves a modified search field", TRUE);
vlPref.Replace (prefs, "search_causes_wildcard_completion", vlYesNoVT,
    "searching with a wildcard in a search field causes the wildcard to be replaced with a string, if there is only one unique completion to the wildcard",
                TRUE);
vlPref.Replace (prefs, "use_tmpdir", vlYesNoVT,
    "Use $TMPDIR for storing intermediate files created during annotation.  Current directory is used if FALSE or if $TMPDIR is unset",
                TRUE);
*/
vlPref.Replace (prefs, "encap_tool", vlStringVT,
    "~~name of tool encapsulated",
                "ViewDraw");
vlPref.Replace (prefs, "encap_filename", vlStringVT,
    "~~encapsulation file which provides _Add and _Annotate methods",
                "vdbVdraw.vs");
vlPref.Replace (prefs, "encap_attr_name", vlStringVT,
    "~~attribute name whose value is passed as first argument to _Add method",
                "SYMBOL");
vlPref.Replace (prefs, "debug", vlYesNoVT,
                "Print messages to enable debugging configuration problems",
                vlYesNo.No);
vlPref.Replace (prefs, "search_for_symbol", vlYesNoVT,
                "Library name cannot be found from symbol name through the normal mechanism, index.par.  Instead, search all libraries for one containing the named symbol.",
                vlYesNo.No);

vlPref.SetShorthand (vcFac.Name (fac));
/* must call vlPref.Parse for any settings in powerview.ini to take effect */
vlPref.Parse ("powerview", wv);

function SearchAllLibrariesForSymbol()
    vlPref.Val (prefs, "search_for_symbol") == vlYesNo.Yes;

function EncapGetVtype()
    vlPref.Val (prefs, "encap_attr_name");

function EncapGetToolName()
    vlPref.Val (prefs, "encap_tool");

if (vlPref.Val (prefs, "debug"))
{
    set_stdout (TRUE);
    DEBUG := printf;
}
else
    DEBUG := func(args...);;
function vdbDebug()
    vlPref.Val (vdb_prefs, "debug") == vlYesNo.Yes;


/*
 * Load "vdbutil" first; it defines new enums.
 */
load ("vdbutil.vs");
load ("vdbgrp.vs");
load ("vdbde.vs");
/* later code depends on user configuration -- do it now */
load ("vdbopt.vs");
vdbCfgReadConfigFile ();

function Label(s)
    vcRegion.Create (s, vcLabel.fac, s);

function Label2(s, xCustomFont)
{
    rgn := vcRegion.Create (s, vcLabel.fac, s);
    if (!null (xCustomFont))
        vcRegion.Font (rgn, xCustomFont);
    rgn;
}

function DataLabel(s)
{
/*
    rgn := vcRegion.Create (s, vcLabel.fac, s);
    vcRegion.Font (rgn, vgFont.mediumb);
    rgn;
*/
    vcRegion.Create (s, vcStaticText.fac, s);
}

iTableHspacing := 10;

/*
 * Create a closure for use with vcCmdline.CallOnReturn, with some
 * important stuff in the environment.
 * P.S. I'm not sure that stuff is important any more.
 */
function SearchHandleReturnFn(this, IDontThinkThisIsUsed)
    func(event, sNewValue)
        vcWin.DefaultAction (vcEvent.Window (event), event);
    ;


/*
 * Create a closure for use with vcCmdline.CallOnChange, with some
 * important stuff in the environment.
 */
function SearchHandleChangeFn(this, rgnCmdline, sVtype)
    func(sNewValue)
    {
        this.bSearchCriteriaChanged = TRUE;
        /*
         * `bChangeFlag' will be TRUE if we are in the midst of
         * programatically changing it via vcCmdline.Set.  Don't treat
         * that data as user specified.
         */
        if (!this.bChangeFlag)
        {
            this.rgnLastChanged = rgnCmdline;
            CmdlineSetValueSource (this, rgnCmdline, sVtype,
                                        vdbValueSource.UserSpecified);
        }
    }
    ;

/*
 * Returns TRUE if the given region is a search field.  Used for setting
 * the default button in the button row.  Called from
 * vcRegion.CallOnFocusChange, so it has to be fast.
 */
function RgnIsSearchField(this, rgn)
    if (null (rgn) || vcRegion.Destroyed (rgn))
        FALSE;
    else
        !null (vlSym.Fetch (this.symVtypeToSearchField, vcRegion.Name (rgn)));

/*
 * Create a closure for use with vcRegion.CallOnFocusChange.
 * When tabbing from a search field that has been changed, refine the
 * search.
 */
function SearchHandleFocusChangeFn(this)
    func(rgnNewFocus)
        if (rgnNewFocus != nil)
        {
            /* this is a duplicate of SearchMaybeChangeCriteria, but */
            /* right here I don't want any function overhead */
            if (this.bSearchCriteriaChanged)
                SearchReallyChangeCriteria(this);

            i := (rgnNewFocus == this.rgnButnRow
                  ? this.iAddButton
                  : this.iSearchButton);
            if (this.iCurrButn != i
                && vcRegion.IsEnabled (vcButnRow.Get(this.rgnButnRow,i)))
            {
                this.iCurrButn = i;
                vcButnRow.SetDefault (this.rgnButnRow, i);
            }
        }
    ;

/* get status label string */
function OrgGetLabel()
    if (vdbCfg.eOrg == vdbOrganized.ByLibrary)
        "Library";
    else
        vdbCfg.sOrgViewName;

/* get searchable vtype */
function OrgGetVtype()
    if (vdbCfg.eOrg == vdbOrganized.ByLibrary)
        "_VLLM_LIBRARY_";
    else
        vdbCfg.sOrgViewName;

/* get status display string */
function OrgGetText(this)
    if (null (this.sCategory))
        "none";
    else
        this.sCategory;

/* get status display string */
/*
function GrpGetText(this)
    if (this.eMode == vdbMode.BackAnnotate)
        sprintf ("%d of %d", GrpGetCurrGroup (this) + 1,
                 GrpGetNumGroups (this));
    else
        "--";
*/

/* get status display string */
function CandGetText(this)
    if (this.iCandidates == -1)
        "--";
    else
        number2string (this.iCandidates);

function SearchInfoCreate(this)
{
    rgnInfoTable :=
        vcTable.Make ("info display", 2, 2);
    vcTable.Add (rgnInfoTable, Label (OrgGetLabel () + ":"));
    vcTable.Add (rgnInfoTable, DataLabel (OrgGetText (this)));
    vcTable.Add (rgnInfoTable, Label ("Candidates:"));
    vcTable.Add (rgnInfoTable, DataLabel (CandGetText (this)));

    vcTable.Col (rgnInfoTable, 0, vcTable.Border.Invisible,
                 iTableHspacing, iTableHspacing, iTableHspacing,
                 vgAlign.MiddleRight);
    vcTable.Col (rgnInfoTable, 1, vcTable.Border.Invisible,
                 iTableHspacing, iTableHspacing, iTableHspacing,
                 vgAlign.MiddleLeft);
    vcTable.Row (rgnInfoTable, 1, vcTable.Border.Invisible, 5, 5, 5,
                 vgAlign.LowerLeft);

    rgnInfoTable;

}

function SearchInfoUpdateDisplay(this)
{
    /* HACK_ALERT: table locations are hard-wired */
    vcRegion.Set (vcTable.Get (this.rgnInfoArea, 0, 1), OrgGetText (this));
    vcRegion.Set (vcTable.Get (this.rgnInfoArea, 1, 1), CandGetText (this));

    /* Be careful where you do this; it causes flash. */
    /* Definitely don't do it here. */
    /*AlignColumns (this);*/

}

function AlignColumns(this)
{
    if (this.eMode != vdbMode.Idle)
        vcTable.AlignColumns (list (this.rgnInfoArea, this.rgnSearchArea));
}

/*
 * Pops up a picklist dialog, calls func(this, value) when a value is
 * picked.
 */
function DialogCreate(this, sTitle, lList, fn)
{
    declare rgn, win, tab, rgnPicks, rgnButnRow;
    declare lCurrButtons; /* keeps track of current state of button row
                             to eliminate unnecessary flashing */

    gLink := ""; /* Variable for storing links */

    vdm_cntx := vllm.CntxGetVdmCntx(this.cntx);

    /*
     * RETURNS
     *      TRUE if string value is a link (starts with '@')
     *
     * SIDE EFFECTS
     *      If value is a link, sets global var `gLink'
     */
    function SetgLink(link)
    {
        /* Check to see if its a cons cell from vcPicklist.Get */
        if(ispair(link))
            link = car(link);
        /* strip the @ and make it global */
        if (istype(link,vlStringVT) && !string_eq("",link) && (link[0] == '@'))
        {
            gLink = substring(link,1,0); 
            TRUE;
        }
        else
            FALSE;
    }

    function accept(ev)
    {
        sValue := vcRegion.Get (rgnPicks, vlStringVT);
        fn (this, sValue);
    }

    /*
     * Invoke editor, reporting any untimely demise to an alert box.
     */
    function view(ev)
    {
        err_strs := "Error invoking viewer on object `" + gLink + "':\n\n";
        vdm.ObjInvokeEditor (
            vdm.CntxGetObjFromLogicalName (vdm_cntx, gLink, vdm.VersLatest),
            nil,
            func(output)
                /* Buffer the error messages until exit */
                err_strs = err_strs + output;,
            func(mode, code)
            {
                if ((mode == vcSysMode.Exited) && (code == 0))
                {
                    if (!null (win) && vcWin.IsAlive (win))
                        vcWin.AddStatus (win, "done");
                }
                else
                {
                    death_msg := ((mode == vcSysMode.Signaled)
                                    ? "killed with signal "
                                    : "exited with status ")
                        + number2string (code);
                    if (!null (win) && vcWin.IsAlive (win))
                        vcWin.AddStatus (win, death_msg);
                    err_strs = err_strs + "\nViewer " + death_msg;

                    /* Important: don't throw an exception here! */
                    vdbReport (err_strs);
                }
            });
        vcWin.ClearStatus (win);
        vcWin.AddStatus (win, "Spawning viewer...");
    }

    function fetch(ev)
        FetchFunc()(vdm.CntxGetObjFromLogicalName (vdm_cntx, gLink, 
                                                   vdm.VersLatest));

    /* Set up different button rows for link and direct attributes */
    lButtons :=
        list (list ("Accept", "Accept", accept,
                    list (close_window <- TRUE)),
              list ("Cancel", "Cancel",
                    func(event);,
                    list (close_window <- TRUE)));
    if (FetchEnabled ())
        lButtonsLink :=
            list (list ("Accept", "Accept", accept,
                        list (close_window <- TRUE)),
                  list ("View", "View",view, nil),
                  list ("Fetch", "Fetch", fetch, nil),
                  list ("Cancel", "Cancel",
                        func(event);,
                        list (close_window <- TRUE)));
    else
        lButtonsLink :=
            list (list ("Accept", "Accept", accept,
                        list (close_window <- TRUE)),
                  list ("View", "View", view, nil),
                  list ("Cancel", "Cancel",
                        func(event);,
                        list (close_window <- TRUE)));

    tab = vcTable.Create(sTitle,2,1);

    /*
     * Resets the button row to be appropriate for the selected value;
     * some may be links and others not.
     */
    function SetCurrent(elem, on_off, index)
        if (on_off)
        {
            lTheseButtons := (SetgLink(elem) ? lButtonsLink : lButtons);
            if (!equal (lTheseButtons, lCurrButtons))
            {
                lCurrButtons = lTheseButtons;
                rgnButnRow = 
                    vcRegion.Create ("OkOrCancel:butnRow", vcButnRow.fac,
                                     lTheseButtons);
                vcTable.Set (tab,1,0,rgnButnRow);
            }
            if (!null (win) && vcWin.IsAlive (win))
                vcWin.ClearStatus (win);
        }

    rgnPicks = vcRegion.Create (sTitle, vcPickEdit.fac, lList,
                                height <- 7);
    vcPickEdit.CallOnChange (rgnPicks,SetCurrent);
    vcTable.Set (tab, 0, 0, rgnPicks);

    if(!null(lList))
        elem := vcPicklist.Get(rgnPicks,0,0);
    else
        elem := "";
    SetCurrent (elem, vlOnOff.On, 0);

    rgn = vcRegion.Create (sTitle, vcMargin.fac, tab);
    /* HACK_ALERT: leave vcWin.NoStatus OFF, because that forces the */
    /* window wide enough to see the title in the titlebar.  Need a more */
    /* elegant way of solving this problem. */
    win = vcWin.Create (rgn, /*vcWin.NoStatus + */vcWin.NoBindings);
    vcWin.Forward (vcRegion.Window (this.rgnThis), win);

} /* DialogCreate */

function CmdlineSetValue(this, rgn, sValue)
{
    this.bChangeFlag = TRUE;
    vcCmdline.Set (rgn, sValue);
    this.bChangeFlag = FALSE;

}

function ListMatchingStringValues(this, sVtype)
{
    /*DEBUG("this.bSearched = %s\n", this.bSearched);*/
    if (this.bSearched)
        l := vllm.CntxGetMatchesString (this.cntx, sVtype);
    else
        l := vllm.CntxGetAllValuesString (this.cntx, sVtype);
    /*print_list("matching string values",l);*/
    l = vscript.Sort (l, string_le);
    /*print_list("matching string values after sort",l);*/
    DialogCreate (this, sVtype, l,
                  func(this, sValue)
                      if (!null (rgn := vlSym.Fetch
                                 (this.symVtypeToSearchField, sVtype)))
                      {
                          CmdlineSetValue (this, rgn, sValue);
                          CmdlineSetValueSource (this, rgn, sVtype,
                                                 vdbValueSource.UserSpecified);
                          this.rgnLastChanged = rgn;
                          SearchReallyChangeCriteria (this);
                      }
                  );

}

/*
symViewNameToUnits := vlSym.StrCreate (17);
vlSym.Dynamic (symViewNameToUnits, 2.0, 2.0);

function CategoryNormalUnits(sCategory, sViewName, eUnits)
    vlSym.Store (symViewNameToUnits,
                 (null (sCategory)
                  ? sViewName
                  : sCategory + ":" + sViewName),
                 eUnits);

function GetNormalUnits(sCategory, sViewName)
{
    // first try "category:viewname" then "viewname" then overall default
    eUnits := vlSym.Fetch (symViewNameToUnits,
                           (null (sCategory)
                            ? sViewName
                            : sCategory + ":" + sViewName));
    DEBUG("1: eUnits=%s\n", eUnits);
    if (null (eUnits))
    {
        eUnits = vlSym.Fetch (symViewNameToUnits, sViewName);
        DEBUG("2: eUnits=%s\n", eUnits);
        if (null (eUnits))
        {
            eUnits = vlSym.Fetch (symViewNameToUnits, nil);
            DEBUG("3: eUnits=%s\n", eUnits);
        }
    }

    eUnits;

}
*/

function ListMatchingFloatValues(this, sVtype)
{
    /* HACK_ALERT: default magnitude not supported yet */
    /*eUnits := GetNormalUnits (this.sCategory, sViewName);*/

    /* HACK_ALERT: this is a duplication of code in vllmCvtDformatDefault */
    ulFlags := vllmCvt.MagDb + vllmCvt.Trunc;
    if (!null (vllm.VtypeGetUnits (vllm.CntxFindVtype (this.cntx, sVtype))))
    {
        val := vlPref.Val (vllm.prefs, "append_units");
        if (val == vllmAppendUnits.Full)
            ulFlags = ulFlags + vllmCvt.LUnits;
        else if (val == vllmAppendUnits.Abbrev)
            ulFlags = ulFlags + vllmCvt.Units;
    }

    if (this.bSearched)
        l := vllm.CntxGetMatchesFloat (this.cntx, sVtype,
                                       /*eUnits*/ vllmMag.None, ulFlags);
    else
        l := vllm.CntxGetAllValuesFloat (this.cntx, sVtype,
                                       /*eUnits*/ vllmMag.None, ulFlags);

    /*print_list("matching float values",l);*/
    l = vscript.Sort (l, func(a,b) le(string2number(a),string2number(b)););
    /*print_list("matching float values after sort",l);*/
    DialogCreate (this, sVtype, l,
                  func(this, sValue)
                      if (!null (rgn := vlSym.Fetch
                                 (this.symVtypeToSearchField, sVtype)))
                      {
                          CmdlineSetValue (this, rgn, sValue);
                          CmdlineSetValueSource (this, rgn, sVtype,
                                                 vdbValueSource.UserSpecified);
                          this.rgnLastChanged = rgn;
                          SearchReallyChangeCriteria (this);
                      }
                  );

}

/*
 * Returns list of attrs to be displayed as search fields in search
 * criteria groupbox.
 *
 * NB: See algorithm described in "vdbum.scm".  If this changes, change
 * those comments!
 */
function GetDisplayedAttrs(this)
{
    lAttrs :=
        vlSym.Fetch (vdbCfg.symCategoryToDisplayedAttrs, this.sCategory);
    if (null (lAttrs))
    {
        if (vdbCfg.eOrg == vdbOrganized.ByLibrary)
        {
            /*
             * If null(this.sCategory), we have no choice but to use the
             * list of all vtypes in all libraries.  This has the distinct
             * possibility of making the window so large as to be unusable.
             * Be sure not to include attr names which are mapped to
             * multiple vtypes, or else we won't be able to map back from
             * the attr to the vtype!
             */
            declare lTemp;
            if (null (this.sCategory))
            {
                foreach (vtype; vllm.CntxLoopVtype (this.cntx))
                {
                    sVtype := vllm.VtypeGetName (vtype);
                    sAttr := VtypeToAttr (sVtype);
                    if (!AttrHasManyMappings (sAttr))
                        lTemp = cons (vllm.VtypeGetName (vtype), lTemp);
                }
            }
            else
                lTemp = vdb_cb.LibGetVtypes (this.cntx, this.sCategory);
            /*print_list("List of displayed vtypes", lTemp);*/
            lTemp := VtypeToAttrList (lTemp);
            /*print_list("List of displayed attrs", lTemp);*/
            /* we know lAttrs==nil */
            foreach (e; vscript.list_iter (lTemp))
                if (null (vlSym.Fetch (vdbCfg.symExcludedAttrs, e)))
                    lAttrs = cons (e, lAttrs);
            /* sort it */
            lAttrs = vscript.Sort (lAttrs, string_le);
        }
        else
            lAttrs = vlSym.Fetch (vdbCfg.symCategoryToDisplayedAttrs, nil);
    }

    if (null (lAttrs))
        vdbThrow (1000, "The list of attributes to display for category `%s'\n is empty, and cannot be deduced.", this.sCategory);

    /* return value */
    lAttrs;

}

/*
 * Returns list of all possible category values.
 */
function GetCategories(this)
{
    declare l;
    if (vdbCfg.eOrg == vdbOrganized.ByLibrary)
        l = vdb_cb.CntxGetLibs (this.cntx);
    else
        l = vllm.CntxGetAllValuesString (this.cntx, vdbCfg.sOrgViewName);

    l = vscript.Sort (l, string_le);

}

/*
 * Set/unset the oat flag for all attributes.
 */
function OatsToggleAll(this)
{
    /* Find the oat flag for the first attribute & flip it */
    rgn := vcRegion.FindFac (this.rgnSearchArea, vcToggleButton.fac);
    if (null (rgn))
        vdbThrow (1001, "Can't find any oat flags to toggle");
    b := ! vcRegion.Get (rgn, vscmVT);
    fn := (b) ? vcToggleButton.Set : vcToggleButton.Unset;
    foreach (rgn; vcRegion.Children (this.rgnSearchArea, TRUE))
        if (vcRegion.Fac (rgn) == vcToggleButton.fac)
        {
            fn (rgn);
            vcRegion.QueueForRefresh (rgn);
        }

    /* Apparently, programmatic set/unset of a vcToggleButton does not
       cause its action function to be called. */
    foreach (sVtype, rgnCmdline; vlSym.Loop (this.symVtypeToSearchField))
        OatsSet (this, sVtype, b);
}

/*
 * Set/unset the oat flag for one attribute.
 */
function OatsSet(this, sVtype, b)
    if (b)
        vlSym.Store (this.symVtypeToOat, sVtype, TRUE);
    else
        vlSym.Remove (this.symVtypeToOat, sVtype);

/*
 * Ensure that library `sName' is loaded, if !null(sName).
 * If null(sName), ensure that all libraries are loaded.
 */
function EnsureLoaded(this, sCategory)
    /*
     * If not organized by library, then all libraries have already been
     * loaded, because load_on_demand has been turned off...
     */
    if (vdbCfg.eOrg == vdbOrganized.ByLibrary)
    {
        /* if searching across categories, we have to load all libraries */
        if (null (sCategory))
            foreach (lib; vllm.CntxLoopLib (this.cntx))
                vllm.LibEnsureLoaded (lib);
        else
        {
            lib := vllm.CntxFindLib (this.cntx, sCategory);
            if (null (lib))
                /* This can't happen... */
                vdbThrow (1018, "Library not found: %s", sCategory);
            vllm.LibEnsureLoaded (lib);
        }
    }

/*
 * Makes sure that the library we're about to do some searches in is already
 * loaded.  This is needed to support the "vllm.load_on_demand" preference.
 */
function LoadOnDemand(this)
    if (this.eMode != vdbMode.Idle)
        EnsureLoaded (this, this.sCategory);

/*
 * Creates and returns the search criteria groupbox.
 *
 * SIDE EFFECTS
 *      Sets `this.rgnSearchArea'; to a vcTable rgn, or if idle, to a vcRubber rgn
 *
 *      Inits hash tables `this.symVtypeToSearchField', `this.symVtypeToValueSource'
 */
function SearchCreate(this)
{
    /* Adds the column headers.  Duh.
     */
    function AddColumnHeaders()
    {
        eFont := vgFont.smallb;
        rgnButn := vcRegion.Create("", vcButton.fac,
                                   func(ev) OatsToggleAll(this);,
                                   tip <- "Toggle OAT flag of all attributes");
        rgnLabel := Label2 ("oat", eFont);
        rgnBorder := vcRegion.Create ("", vcBorder.fac, rgnLabel,
                                      left_space <- 1,
                                      right_space <- 1,
                                      invisible <- TRUE,
                                      showfocus <- TRUE);
        vcRegion.AddChild (rgnButn, rgnBorder);
        vcRegion.SetCursor (rgnButn, vgCursor.Hand);
        vcRegion.FocusInhibit (rgnButn);
        vcButton.HighlightRegion (rgnButn, rgnBorder);
        /* Note that the leftmost two labels go in a table by themselves
         * so that AlignColumns() works nicely.
         */
        rgnLabelTable := vcTable.Make ("", 1, 2,
                                       Label2("attribute", eFont),
                                       rgnButn);
        vcTable.Col (rgnLabelTable, 1, vcTable.Border.Invisible,
                     10, 10, 10,
                     vgAlign.MiddleLeft);
        vcTable.Add (rgnSearchArea, rgnLabelTable);
        vcTable.Add (rgnSearchArea, Label2(" value", eFont));
        vcTable.Add (rgnSearchArea, Label2("", eFont));
    }

    /* Creates the cool button which toggles oat status
     */
    function OatButtonCreate(this, sVtype)
    {
        fn := func(ev, b) OatsSet(this, sVtype, b);;
        rgn := vcRegion.Create (sVtype+" oattoggle", vcToggleButton.fac,
                                vdbCfg.bOatsOnByDefault,
                                action <- fn);
        if (vdbCfg.bOatsOnByDefault)
            OatsSet (this, sVtype, TRUE);
        vcRegion.FocusInhibit (rgn);
        vcRegion.SetCursor (rgn, vgCursor.Hand);
        rgn;
    }

    /* Creates the wonderful button to the right of the search field which
     * lists matching values.
     */
    function ButtonCreate(this, sVtype)
    {
        rgnArrow  := vcRegion.Create ("", vcArrow.fac, 3);
        rgnBorder := vcRegion.Create ("", vcBorder.fac, rgnArrow);
        if (vllm.VtypeGetBase (vllm.CntxFindVtype (this.cntx, sVtype))
            == vllmBase.Float)
            fn := func(event) ListMatchingFloatValues (this, sVtype);;
        else
            fn := func(event) ListMatchingStringValues (this, sVtype);;
        rgnButton := vcRegion.Create (sVtype+" listbutton", vcButton.fac, fn,
                                      tip <- "List matching values");

        vcRegion.AddChild (rgnButton, rgnBorder);
        vcButton.HighlightRegion (rgnButton, rgnBorder);

        vcRegion.FocusInhibit (rgnButton);
        vcRegion.SetCursor (rgnButton, vgCursor.Hand);

        rgnButton;

    }

    /* Add a field consisting of label + cmdline etc.
     * NB: this function uses variables local to this scope
     */
    function AddField(sAttr)
    {
        /* throw if the vtype doesn't exist; we can't really deal with it */
        sVtype := AttrAndCategoryToVtype (this.sCategory, sAttr);
        vtype := vllm.CntxFindVtype (this.cntx, sVtype);
        if (null (vtype))
            vdbThrow (1002, "Can't display field for attribute %s%s\nbecause no such attribute has been defined.",
                      sAttr,
                      /* include vtype name if it's been mapped */
                      string_eq(sAttr,sVtype)?"":" (dbattr "+sVtype+")");

        /* label with attr name -- if required view, make label bold */
        bIsRequiredView := assoc (sVtype, vdbCfg.alRequiredViews);
        sLabel := (vllm.VtypeGetBase (vtype) == vllmBase.Float
                 ? sAttr + " (n)"
                 : sAttr + " (s)");
        rgnLabel := Label2 (sLabel, bIsRequiredView ? vgFont.smallb : nil);

        /* oat flag button */
        if (vdbCfg.bOatsEnabled)
        {
            rgnOatButton := OatButtonCreate (this, sVtype);
            /* Note that the label & button go in a table by themselves so
             * that AlignColumns() works nicely.
             */
            rgnLabel = vcTable.Make ("", 1, 2, rgnLabel, rgnOatButton);
            /*vcTable.Col (rgnLabelTable, 0, vcTable.Border.Invisible,
              0, 0, 0, vgAlign.MiddleRight); // not needed, apparently */
            vcTable.Col (rgnLabel, 1, vcTable.Border.Invisible,
                         5, 5, 5, vgAlign.MiddleLeft);
        }
        vcTable.Add (rgnSearchArea, rgnLabel);

        /* cmdline -- important that region name be vtype */
        rgnCmdline := vcRegion.Create (sVtype, vcCmdline.fac, "",
                                      width <- 20);
        vlSym.Store (this.symVtypeToSearchField, sVtype, rgnCmdline);
        vlSym.Store (this.symVtypeToValueSource, sVtype,
                     vdbValueSource.NotSet);
        vcRegion.Background (rgnCmdline, vgAllColor.Background, TRUE);
        vcTable.Add (rgnSearchArea, rgnCmdline);
        vcCmdline.CallOnChange (rgnCmdline,
                                SearchHandleChangeFn (this, rgnCmdline,
                                                      sVtype));
        vcCmdline.CallOnReturn (rgnCmdline,
                                SearchHandleReturnFn (this, sVtype));

        /* list button */
        vcTable.Add (rgnSearchArea, ButtonCreate (this, sVtype));
    }

    /* --- end of local functions --- */

    /* maintain a mapping from vtype to search field region */
    if (null (this.symVtypeToSearchField))
    {
        this.symVtypeToSearchField = vlSym.StriCreate (17);
        vlSym.Dynamic (this.symVtypeToSearchField, 2.0, 2.0);
        this.symVtypeToValueSource = vlSym.StriCreate (17);
        vlSym.Dynamic (this.symVtypeToValueSource, 2.0, 2.0);
    }
    else
    {
        vlSym.Clear (this.symVtypeToSearchField);
        vlSym.Clear (this.symVtypeToValueSource);
    }

    LoadOnDemand (this);

    /*
     * Bail out before creating search fields if we're idle.
     */
    if (vdbCfg.eOrg == vdbOrganized.ByLibrary
        && this.eMode == vdbMode.Idle)
    {
        this.rgnSearchArea = vcRubber.Create ("", 100, 50);
        return (LabelBorderCreate ("Search Criteria", this.rgnSearchArea));
    }

    /* Get the list of displayed attrs for this category. */
    lDisplayedFields := GetDisplayedAttrs (this);

    /*
     * Create the table, fill it in, align it.
     */
    rgnSearchArea :=
        vcTable.Create ("search area",
                        length (lDisplayedFields)
                        + ((vdbCfg.bOatsEnabled) ? 1 : 0),
                        3);

    if (vdbCfg.bOatsEnabled)
        AddColumnHeaders ();

    foreach (sAttr; vscript.list_iter (lDisplayedFields))
        AddField (sAttr);

    /*
     * Add search fields for all the required views, if not already there.
     */
    foreach (l; vscript.list_iter (vdbCfg.alRequiredViews))
        if (null (vlSym.Fetch (this.symVtypeToSearchField, car (l))))
            AddField (car (l));

    vcTable.Col (rgnSearchArea, 0, vcTable.Border.Invisible,
                 0, 0, 0, /* these numbers don't matter */
                 vgAlign.MiddleRight);
    vcTable.Col (rgnSearchArea, 1, vcTable.Border.Invisible,
                 /*iTableHspacing, iTableHspacing, iTableHspacing,*/
                 0, 0, 0,
                 vgAlign.MiddleLeft);
    vcTable.Row (rgnSearchArea, -1, vcTable.Border.Invisible,
                 3, 3, 3, vgAlign.MiddleLeft);

    this.rgnSearchArea = rgnSearchArea;

    /*
     * Putting the table in a vcTable.Scroll3 looks awful.
     * Putting it in a vcScroll region doesn't look so good either, plus
     * it's not easy to limit the initial size in the vertical direction.
     * Use the low-tech approach, avoiding the use of scrolling unless the
     * number of search fields is unweildy.
     */
    if (length (lDisplayedFields) > 12)
        rgnSearchArea :=
            vcTable.Scroll3 ("search criteria scroll",
                             rgnSearchArea, rgnSearchArea,
                             5, 10, 0,
                             0, 0, 0,
                             list (vertical <- vcScroll.Presence.Sometimes,
                                   horizontal <- vcScroll.Presence.Never));

    /* RETURN VALUE */
    LabelBorderCreate ("Search Criteria", rgnSearchArea);

} /* SearchCreate */

function SearchFieldsChangeDisplay(this)
{
    rgn := SearchCreate (this);

    /* HACK_ALERT: hard-coded table location */
    vcTable.Set (this.rgnMainTable, 2, 0, rgn);

    /* Be careful where you do this; it causes flash. */
    AlignColumns (this);

    /*DEBUG ("SearchFieldsChangeDisplay: focus is %s\n",vcRegion.GetFocus(rgn));*/
    if (vcRegion.GetFocus (rgn) == nil)
        vcRegion.SetFocus (rgn, rgn);

}


/* change appearance of command line if the type of value stored there */
/* changes */
function CmdlineSetValueSource(this, rgn, sVtype,
                               vdbValueSourceVT eValueSource)
{
    eOldValueSource := vlSym.Fetch (this.symVtypeToValueSource, sVtype);

    if (eValueSource > eOldValueSource)
        CmdlineReallySetValueSource (this, rgn, sVtype, eValueSource);

}


function CmdlineReallySetValueSource(this, rgn, sVtype,
                                     vdbValueSourceVT eValueSource)
{
    /*DEBUG("\t%15s changes to %s\n",sVtype,convert(vlStringVT,eValueSource));*/
    vlSym.Store (this.symVtypeToValueSource, sVtype, eValueSource);

    if (vdbCfg.bTextColorEnabled)
    {
        if (eValueSource == vdbValueSource.UserSpecified
            || eValueSource == vdbValueSource.NotSet)
            color := vgAllColor.Foreground;
        else if (eValueSource == vdbValueSource.CommonView)
            color := vdbCfg.eTextColorCommonView;
        else
            color := vdbCfg.eTextColorLoadedView;

        vcRegion.Color (rgn, color);
        vcRegion.Refresh (rgn, vcRegion.VisibleArea (rgn));
    }

}


function SearchFieldsDisplayCommonViews(this, alCommonViews)
{
    foreach (l; vscript.list_iter (alCommonViews))
        if (! null(rgn := vlSym.Fetch (this.symVtypeToSearchField, car (l))))
        {
            CmdlineSetValue (this, rgn, cdr (l));
            CmdlineSetValueSource (this, rgn, car (l),
                                   vdbValueSource.CommonView);
        }

    /* because above junk modified the cmdlines */
    this.bSearchCriteriaChanged = FALSE;

}


/*
 * DESCRIPTION
 *      Immediately before or after ExecSearch, we'll want to clear all
 *      the old common views, which may no longer be applicable to the
 *      search.
 */
function SearchFieldsClearCommonViews(this)
    foreach (l; vscript.list_iter (this.alCommonViews))
        if (! null(rgn := vlSym.Fetch (this.symVtypeToSearchField, car (l))))
            if (vlSym.Fetch (this.symVtypeToValueSource, car (l))
                == vdbValueSource.CommonView)
            {
                CmdlineSetValue (this, rgn, "");
                CmdlineReallySetValueSource (this, rgn, car (l),
                                             vdbValueSource.NotSet);
            }

function LabelBorderCreate(sLabel, rgnChild)
    vcRegion.Create ("label border", vcGroupBox.fac, rgnChild,
                     label <- sLabel);

/* HACK_ALERT: just to save time creating contexts... */
if (!isbound (`HackCntx, current_package ()))
    HackCntx := nil;

function _Destroy(this)
{
    HackCntx = this.cntx;
    ItcUnregisterAll (this);

}

/**********************************************************************/
/* _Create -- create an instance of this facility
 *
 * DESCRIPTION
 *      `rgnThis' is our very own Region ID, created by Core.
 *
 * RETURNS
 *      A value that will be passed by Core to all our methods and commands.
 */
function _Create(sCategory, rgnThis)
{
    /*
     * Facility data object is a ViewScript structure.
     */
    this := struct
    {
        /*
         * In the event of a separation between search-status-related stuff
         * (a new "vdbForm" facility which could be multiply instantiated)
         * and application-related stuff (a "vdbTop" facility),
         *
         *----- this stuff would go with new vdbForm: -----
         */

        /* UI stuff */
        rgnThis = rgnThis;
        rgnMainTable;
        rgnTabs;
        rgnInfoArea;
        rgnSearchArea;
        rgnButnRow;
        rgnLastChanged;

        /* search stuff */
        symVtypeToSearchField;  /* maps vtype to search field region */
        symVtypeToValueSource;  /* maps vtype to where value came from */
        symVtypeToOat;          /* maps vtype to oat flag */
        sCategory = sCategory;  /* category (or library name) */
        iCandidates;            /* # candidates */
        alCommonViews;          /* list of vtype/value pairs */
        sLibCompName;           /* unique component selected, or nil */
        bSearchCriteriaChanged = FALSE;
        bSearched              = FALSE;
        bChangeFlag            = FALSE;

        /* button row maintenance */
        iSearchButton;
        iAddButton;
        iCurrButn;

        lItcRegistrations;      /* list of itc registration objects */
        lCompsToAnnotate;
        eMode;

        /*
         *----- this stuff would go with vdbTop: -----
         */

        cntx;                   /* vllm cntx */

        hGroups                 /* handle to groups (or nil if in add mode) */
    };

    /* set start mode properly */
    this.eMode = (null (sCategory) ? vdbMode.Idle : vdbMode.AddGeneric);

    /* Create vllm context */
    /* HACK_ALERT: to save time creating contexts while debugging,
       save it away under the name `HackCntx'... */
    if (null (HackCntx))
    {
        HackCntx = vllm.CntxCreate ("vdbForm");

        /* can't have load-on-demand if organized by named vtype -- we have to
         * be able to search all comps for those matching the named vtype
         * Note that this must be done before vllm.CntxInit.
         */
        if (vdbCfg.eOrg != vdbOrganized.ByLibrary)
            vlPref.Setval (vllm.prefs, "load_on_demand", FALSE);

        vllm.CntxInit (HackCntx);
    }
    else
        vllm.CntxClearSearch (HackCntx);
    this.cntx = HackCntx;

    /* important to have lib loaded if load_on_demand being used */
    if (!null (sCategory)
        && vdbCfg.eOrg == vdbOrganized.ByLibrary)
    {
        lib := vllm.CntxFindLib (this.cntx, this.sCategory);
        if (!null (lib))
            vllm.LibEnsureLoaded (lib);
    }

    if (vdbCfg.bOatsEnabled)
        this.symVtypeToOat = vlSym.StriCreate (17);

    /* Note tabs.  This region gets set via vcTable.Set to either
     * a vcNoteTab region or a vcSteel (blank) region.
     */
    rgnTabs := vcSteel.Create ("", 1, 1);

    this.iCandidates = -1;
    this.rgnInfoArea = SearchInfoCreate (this);
    rgnTop := LabelBorderCreate ("Search Status", this.rgnInfoArea);

    rgnBottom := SearchCreate (this);

    this.rgnButnRow = ButnRowCreate (this);

    this.iAddButton = 0;
    this.iSearchButton = 1;

    this.rgnMainTable =
        vcTable.Make ("main table", 4, 1,
                      rgnTabs,
                      rgnTop,
                      rgnBottom,
                      this.rgnButnRow);

/* this makes matters worse...it only achieves disabling stretching,
   and makes the alignment go funny on window resize.
    vcTable.Row (this.rgnMainTable, vcTable.All, vcTable.Border.Invisible,
                 4, 4, 4,
                 vgAlign.LowerLeft);
*/

    vcRegion.AddChild (this.rgnThis, this.rgnMainTable);
    vcRegion.FocusInhibit (this.rgnThis);
    vcRegion.CallOnFocusChange (this.rgnThis,
                                SearchHandleFocusChangeFn (this));

    /* Be careful where you do this; it causes flash. */
    AlignColumns (this);

    ItcRegisterAll (this);

    if (this.eMode == vdbMode.Idle)
        SetIdleStateVariables (this);
    else
    {
        SearchAddCategory (this);
        AddRequiredViews (this);
        <iCandidates, alCommonViews> := ExecSearch (this);

        this.bSearchCriteriaChanged = FALSE;
        this.sLibCompName = nil;
        this.alCommonViews = alCommonViews;
        SearchMaybeChangeButnRow (this, iCandidates);
        SearchInfoUpdateDisplay (this);
        SearchFieldsDisplayCommonViews (this, this.alCommonViews);
    }

    /*
     * Facility data object is return value.
     */
    this;

} /* _Create */


/*
function after(this, event)
{
    vcWin.ClearStatus (vcRegion.Window (this.rgnThis));
    if (!null (this.sStatus))
    {
        vcWin.AddStatus (vcRegion.Window (this.rgnThis), this.sStatus);
        this.sStatus = nil;
    }

}
*/


load (vlPref.Val (prefs, "encap_filename"));


function MaybeSetMode(this, vdbModeVT eMode)
    if (this.eMode != eMode)
        SetMode (this, eMode);

function ButnRowCreate(this)
{
    declare sButtonName, fnButtonAction;
    declare l;

    if (this.eMode == vdbMode.BackAnnotate)
        l := list (list ("Annotate", "Annotate", cmdAnnotate, nil),
                   list ("Search","Search", cmdSearchExec, nil),
                   list ("Clear","Clear", cmdSearchClear, nil),
                   list ("Candidates","Candidates", cmdListCandidates, nil),
                   list ("Load", "Load", cmdLoadFromVdraw, nil),
                   list ("Reset", "Reset", cmdResetToLoadedValues, nil));
    else
    {
        if (this.eMode == vdbMode.AddUnique)
        {
            sButtonName = "    Add    ";
            fnButtonAction = cmdAddUnique;
        }
        else
        {
            sButtonName = "Add Generic";
            fnButtonAction = cmdAddGeneric;
        }
        l := list (list (sButtonName, sButtonName, fnButtonAction, nil),
                   list ("Search","Search", cmdSearchExec, nil),
                   list ("Clear","Clear", cmdSearchClear, nil),
                   list ("Candidates","Candidates", cmdListCandidates, nil),
                   list ("Load", "Load", cmdLoadFromVdraw, nil));
    }

    /* return value */
    vcRegion.Create ("butnrow", vcButnRow.fac, l);

} /* ButnRowCreate */

function SetIdleStateVariables(this)
{
    this.iCandidates   = -1;
    /*this.alCommonViews = nil;*/ /* need this for Misc->AddMode */
    this.hGroups       = nil;
}

function SetMode(this, vdbModeVT eMode)
{
    eOldMode := this.eMode;
    this.eMode = eMode;

    /*DEBUG ("\tmode changes to: %s\n", eMode);*/

    /* Handle NoteTab creation
     * HACK_ALERT: hard-coded table location
     */
    if (eOldMode != eMode)
    {
        if (eOldMode == vdbMode.BackAnnotate)
        {
            this.rgnTabs = nil;
            vcTable.Set (this.rgnMainTable, 0, 0,
                         vcSteel.Create ("", 1, 1));
        }
        /* We create the vcNoteTab and stick it in the table later,
           because we have to add at least one vcNoteTab immediately
           after creation to work around a bug.
         */
    }

    /*this.sLibCompName = nil;*/
    this.lCompsToAnnotate = nil;

    if (eOldMode != eMode)
        this.rgnButnRow = ButnRowCreate (this);

    /*
     * Button 0 is the default button, by default.  Figure out if that's
     * the right thing or not.
     */
    rgn := vcRegion.GetFocus (this.rgnThis);
    if (RgnIsSearchField (this, rgn))
    {
        this.iCurrButn = this.iSearchButton;
        vcButnRow.SetDefault (this.rgnButnRow, this.iSearchButton);
    }

    if (eOldMode != eMode)
    {
        /* HACK_ALERT: hard-coding of table location */
        vcTable.Set (this.rgnMainTable, 3, 0, this.rgnButnRow);

        /* Enable/disable buttons & stuff */
        EnableCmds (this);

        if (eMode == vdbMode.Idle)
        {
            ShowIdleMessage (this);
            SetIdleStateVariables (this);
        }

        /* clear up refresh problems caused by changing butnrow width */
        /*vcRegion.QueueForRefresh (this.rgnThis);*/
        /*vcRegion.QueueForRefresh (this.rgnMainTable);*/
        vcRegion.QueueForRefresh (this.rgnButnRow);
    }

}

/*
 * This is way more complicated than it needs to be.  I want to set
 * preferences on the invocation of the vdbResults facility, but they have
 * to be dynamically determined.  Instead, I changed the PI to the
 * vdbResults facility to take a list of all the things I wanted to pass.
 */
function GetCandidatesData(this)
{
    lComps := vllm.CntxExecSearch2 (this.cntx);
    lAttrs := GetDisplayedAttrs (this);
    lVtypes := AttrToVtypeList (this.sCategory, lAttrs);
    bShowJustCompName := !null(this.sCategory);

    /* return value */
    list (this.cntx, lComps, lAttrs, lVtypes, bShowJustCompName);
}

function UniqueCompSelected(this, event, sLibCompName)
{
    /*DEBUG ("unique comp selected: %s\n", sLibCompName);*/

    this.sLibCompName = sLibCompName;
    this.alCommonViews = vdb_cb.CompGetAllViewValues (this.cntx, sLibCompName);
    SearchMaybeChangeButnRow (this, 1);
    /*DEBUG ("this.iCandidates=%d\n", this.iCandidates);*/
    SearchInfoUpdateDisplay (this);
    SearchFieldsDisplayCommonViews (this, this.alCommonViews);
    vcRegion.SetFocus (this.rgnThis, this.rgnButnRow);

}

function AddSearch(this, sVtype, sPattern)
{
    this.bSearched = TRUE;
/*
    if (vllm.VtypeGetBase (this.cntx, sVtype) != vllmBase.Float)
        mag := vllmMag.None;
    else {
        mag := GetNormalUnits (this.sCategory, sVtype);
        if (null (mag))
            mag = vllmMag.None;
    }
*/
    mag := vllmMag.None;

    /* this is not wonderful, but it works around a missing feature --
     * the ability to undo or to clear a search field.  Note that
     * searching for "*" is not exactly equivalent to not searching;
     * "*" doesn't match components that don't have the specified view.
     */
    if (string_eq (sPattern, ""))
        if (vllm.VtypeGetBase (vllm.CntxFindVtype (this.cntx, sVtype))
            == vllmBase.Float)
            sPattern = "-9e99:9e99";
        else
            sPattern = "*";

    /* if vtype configured that way, add leading/trailing wildcard */
    if (!null (eWildcarding := vlSym.Fetch (vdbCfg.symVtypeToWildcarding,
                                            sVtype)))
    {
        if ((eWildcarding & Wildcarding.Leading) != Wildcarding.NoFlags
            && sPattern[0] != '*')
            sPattern = "*" + sPattern;
        if ((eWildcarding & Wildcarding.Trailing) != Wildcarding.NoFlags
            && sPattern[string_length(sPattern)-1] != '*')
            sPattern = sPattern + "*";
    }

    DEBUG ("AddSearch: %s %s\n", sVtype, sPattern);
    vllm.CntxAddSearch (this.cntx, sVtype, sPattern, mag);
}

function ExecSearch(this)
{
    if (! this.bSearched)
        list (-1, nil);
    else
    {
        ret := vllm.CntxExecSearch1 (this.cntx);
        DEBUG ("ExecSearch yields %d candidates, %d common views\n\t%s\n",
               car(ret), length(cadr(ret)), cadr(ret));
        ret;
    }
}

function SearchReallyChangeCriteria(this)
{
    this.bSearchCriteriaChanged = FALSE;

    if (!null (this.rgnLastChanged)
        && !vcRegion.Destroyed (this.rgnLastChanged))
    {
        sVtype := vcRegion.Name (this.rgnLastChanged);
        sPattern := vcRegion.Get (this.rgnLastChanged, vlStringVT);

        /* don't exec search if search field empty */
/*
        if (string_eq (sPattern, ""))
            vdbStatus (this, "Cannot clear individual fields...use \"Clear\" button");
        else
*/
            vcWin.WithBusy (vcRegion.Window (this.rgnThis), func()
                {
                    AddSearch (this, sVtype, sPattern);
                    SearchFieldsClearCommonViews (this);
                    SearchExecUpdateDisplay (this);
                });
    }

}

function SearchMaybeChangeCriteria(this)
    if (this.bSearchCriteriaChanged)
        SearchReallyChangeCriteria(this);

function SearchButtonChangeCriteria(this, ev)
    SearchReallyChangeCriteria (this);

function AddRequiredViews(this)
    /*if (this.eMode != vdbMode.Idle)*/ /* thought I needed this at first */
        foreach (l; vscript.list_iter (vdbCfg.alRequiredViews))
            AddSearch (this, car (l), cdr (l));

/* Given the list of required views, loop over it and possibly add them */
/* as further search criteria.  If we have a search field for the view, */
/* then change it to "*" only if it is empty (it it isn't empty, the */
/* assumption is that the user typed it).
/* If we don't have a search field for the view, then add a search */
/* criteria of "*".  No visual indication is needed in that case. */
/* See also code in vdbopt.vs */
function MaybeAddRequiredViews(this)
    foreach (e; vscript.list_iter (vdbCfg.alRequiredViews))
    {
        sVtype := car (e);
        rgn := vlSym.Fetch (this.symVtypeToSearchField, sVtype);

        /* don't add to search if we have a user-specified search field */
        if (!null (rgn)
            && vlSym.Fetch (this.symVtypeToValueSource, sVtype)
            < vdbValueSource.FromVdraw)
            AddSearch (this, sVtype, cdr (e));
    }
/* MaybeAddRequiredViews */

function ClearSearch(this)
{
    vllm.CntxClearSearch (this.cntx);
    this.bSearched = FALSE;
    iCandidates := -1;
    alCommonViews := nil;

}

function ClearSearchFields(this)
    foreach (sVtype, rgnCmdline; vlSym.Loop (this.symVtypeToSearchField))
    {
        CmdlineSetValue (this, rgnCmdline, "");
        CmdlineReallySetValueSource (this, rgnCmdline, sVtype,
                                     vdbValueSource.NotSet);
    };

function SearchAddCategory(this)
    /* add category search criteria, if present */
    if (!null (this.sCategory))
        AddSearch (this, OrgGetVtype (), this.sCategory);

function ClearAll(this)
{
    ClearSearchFields (this);
    ClearSearch (this);
    SearchAddCategory (this);

    /* if in BackAnnotate mode, don't allow complete clear;
     * this could cause the data in VDB2 to be out of sync
     * with the database.  See bug #20215.
     */
    if (this.eMode == vdbMode.BackAnnotate)
        GrpSearchAddEncap (this.hGroups, this);

    /* add required views, if present, then update display */
    MaybeAddRequiredViews (this);
    SearchExecUpdateDisplay (this);

} /* ClearAll */

function SearchButtonClear(this, ev)
    ClearAll (this);

/*
function SearchSetRequiredViews(this, ev, alRequiredViews)
{
    vdbCfg.alRequiredViews = alRequiredViews;
    SearchFieldsChangeDisplay (this);
    MaybeAddRequiredViews (this);

}
*/

function SearchChangeCategory(this, sCategory)
{
    this.sCategory = sCategory;
    SearchFieldsChangeDisplay (this);
    ClearSearch (this);
    SearchAddCategory (this);

}

/*
 * DESCRIPTION
 *      Exec search & update GUI.  This is done frequently enough to warrant
 *      its own function.
 *
 *      Call this only when you're finished doing searching etc.  It takes
 *      time to calculate the common views and to update the GUI.
 */
function SearchExecUpdateDisplay(this)
{
    <iCandidates, alCommonViews> := ExecSearch (this);

    this.bSearchCriteriaChanged = FALSE;
    this.sLibCompName = nil;
    this.alCommonViews = alCommonViews;

    SearchMaybeChangeButnRow (this, iCandidates);
    SearchInfoUpdateDisplay (this);
    SearchFieldsDisplayCommonViews (this, this.alCommonViews);

}    

/*
 * DESCRIPTION
 *      Will change the category, and therefore the search fields display,
 *      if `sCategory' != `this.sCategory'.
 *
 *      In any case, the search criteria and search fields will be cleared
 *      and the CATEGORY view added again.
 *
 * NOTE
 *      Does not update the display.  Must call SearchExecUpdateDisplay or
 *      equivalent.
 *
 *      Also does not add required views.  Must call MaybeAddRequiredViews
 *      (or AddRequiredViews).
 */
function SearchMaybeChangeCategory(this, sCategory)
{
    if (SearchCategoryIsDifferent (this, sCategory))
        SearchChangeCategory (this, sCategory);
    else {
        ClearSearch (this);
        ClearSearchFields (this);
        SearchAddCategory (this);
    }
}

/*
 * DESCRIPTION
 *      Can't use `!=' or `string_eq' to compare, since either of these can
 *      be nil...
 */
function SearchCategoryIsDifferent(this, sCategory)
{
    bRet := FALSE;
    if (null (this.sCategory))
    {
        if (!null (sCategory))
            bRet = TRUE;
    }
    else if (null (sCategory) || !string_eq (this.sCategory, sCategory))
        bRet = TRUE;

    bRet;

}

function SearchMaybeChangeButnRow(this, iCandidates)
{
    if (this.iCandidates != iCandidates)
    {
        this.iCandidates = iCandidates;
        if (this.eMode != vdbMode.BackAnnotate)
        {
            if (iCandidates == 1)
                MaybeSetMode (this, vdbMode.AddUnique);
            else
                MaybeSetMode (this, vdbMode.AddGeneric);
        }
    }

} /* SearchMaybeChangeButnRow */

function AddMode(this, e)
    SetMode (this, ((this.iCandidates == 1)
                    ? vdbMode.AddUnique : vdbMode.AddGeneric));

/* I'm sure this won't work without some more work...
function AnnMode(this, e)
    SetMode (this, vdbMode.BackAnnotate);
*/

function SearchByCategory(this, ev, sCategory)
vcWin.WithBusy(vcEvent.Window(ev),func()
{
    MaybeSetMode (this, vdbMode.AddGeneric);
    SearchChangeCategory (this, sCategory);
    AddRequiredViews (this);
    SearchExecUpdateDisplay (this);
});

function SearchAcrossCategories(this, ev)
vcWin.WithBusy(vcEvent.Window(ev),func()
{
    MaybeSetMode (this, vdbMode.AddGeneric);
    SearchChangeCategory (this, nil);
    AddRequiredViews (this);
    SearchExecUpdateDisplay (this);
});

/*
 * RETURNS
 *      attribute name if the vtype should be annotated,
 *      FALSE if not.
 */
function AnnotateVtype(this, sVtype)
{
    /* Annotate any _vtype_ that's got a search field,
     * or any _attr_ that's in the IncludeAttrsWhenAnnotating list
     * but not any _attr_ that's in the ExcludeAttrsWhenAnnotating list
     */
    sAttr := VtypeToAttr (sVtype);
    if ((!null (vlSym.Fetch (this.symVtypeToSearchField, sVtype))
         || member (sAttr, vdbCfg.lIncludeAttrsWhenAnnotating))
        && !member (sAttr, vdbCfg.lExcludeAttrsWhenAnnotating))
    {
        /* don't include views which we got from vdraw and didn't change */
        if (vlSym.Fetch (this.symVtypeToValueSource, sVtype)
            != vdbValueSource.FromVdraw)
            sAttr;
        else
            FALSE;
    }
    else
        FALSE;

    /* DON'T PUT ANY CODE HERE */

} /* AnnotateVtype */

function VtypeGetOat(this, sVtype)
    if (null (this.symVtypeToOat))
        FALSE;
    else
        !null (vlSym.Fetch (this.symVtypeToOat, sVtype));

/*
 * DESCRIPTION
 *      Given
 *           l -- cons of (vtype . value)
 *
 *      Returns
 *           FALSE   if this view should not be annotated
 *           vtype   if it should (vtype will have any qualifier stipped off)
 *
 *      The view should be annotated if either
 *      1. The vtype has no qualifier, or
 *      2. The vtype has a qualifier, and the value matches what's in the
 *      search form.
 *
 * LONG-WINDED DESCRIPTION
 *      This function works around the problem that VLLM returns common
 *      views that conflict with the specified search criteria.  We
 *      basically have to re-search qualifier-extended common views to
 *      filter them out again.  VLLM does this because it derives the common
 *      views from the list of components matching the search criteria, and
 *      doesn't take into consideration the search criteria.
 */
function VtypeQualifierCheck(this, l)
{
    declare vRet;               /* return value */
    sVtype := car (l);
    vTmp := lindex (sVtype, '\\');
    if (!vTmp)
        vRet = sVtype;
    else
    {
        sVtype = substring (sVtype, 0, vTmp);
        if (null (rgn := vlSym.Fetch (this.symVtypeToSearchField, sVtype)))
            vRet = sVtype;
        else
        {
            /*
             * OK, there's a search region.  Only keep this view if its
             * value matches the value in the search region.
             */
            sSearchStr := vcRegion.Get (rgn, vlStringVT);
            vRet = (string_eqi (sSearchStr, cdr (l))
                    ? sVtype
                    : FALSE);
        }
    }

    /* return value */
    vRet;
}

/*
 * INPUT
 *      List of vtypes/values, possibly with qualified views
 *
 * OUTPUT
 *      List of vtypes/values, with no qualified views, and with qualified
 *      views that weren't really common views excluded (see also
 *      VtypeQualifierCheck).
 */
function ExcludeQualifiers(this, lIn)
{
    lOut := nil;
    foreach (l; vscript.list_iter (lIn))
        if (sVtype := VtypeQualifierCheck (this, l))
            lOut = cons (cons (sVtype, cdr (l)),
                         lOut);
    lOut;
}

/*
 * DESCRIPTION
 *      Given a list of vtype/value, return list of attr/value/vis/oat.
 *
 *      This is where user customization comes into play:
 *      1. vtype->attr mapping
 *      2. the attrs to annotate
 *      3. their visibility
 *      4. oats usage
 *      5. undefined value
 *
 * INPUT
 *      AList of attrs/values to annotate (or add), e.g.
 *
 *          (("MFGR" . "TI")
 *           ("VALUE" . "10")
 *           ("CATEGORY" . "Capacitors"))
 *
 * RETURNS
 *      Unsorted list of attrs/values/visibility/oats, e.g.
 *
 *          (("VALUE" "10" "Visible" FALSE)
 *           ("CATEGORY" "Capacitors" "Invisible" FALSE))
 */
function ConsAttrList(this, lIn)
{
    lOut := nil;
    foreach (l; vscript.list_iter (lIn))
    {
        sVtype := car (l);
        if (sAttr := AnnotateVtype (this, sVtype))
            if (vdbCfg.bAnnotateUndef
                || null (vdbCfg.sUndefValue)
                || !string_eq (cdr (l), vdbCfg.sUndefValue))
                lOut = cons (list (sAttr, cdr (l),
                                   vdbCfgGetAttrVisibility (sAttr),
                                   VtypeGetOat (this, sVtype)),
                             lOut);
    }

    /* return value */
    lOut;
}

function DoAdd(this)
{
    if (null (this.alCommonViews))
        vdbThrow (1003, "Can't add component -- no common attributes");

    /* first exclude qualified views */
    alCommonViews := ExcludeQualifiers (this, this.alCommonViews);

    /* next create attr list from common view list */
    lAttrs := ConsAttrList (this, alCommonViews);
/*
    if (null (lAttrs))
        vdbThrow ("Can't add component -- all views excluded.\nUse menu choice \"Config -> Edit config file\" to view configuration options");
*/

    /* Allow overrides through CallOnAdd */
    foreach (fn; vscript.list_iter (vdbCfg.lCallOnAdd))
        lAttrs = apply (fn, list (lAttrs));
/*
    if (null (lAttrs))
        vdbThrow ("Can't add component -- all views excluded through 'CallOnAdd option\n");
*/

    /* Get the value to pass as first arg to _Add based on encapsulation.
     * First look in what was returned from CallOnAdd functions.
     */
    /*print_list("attr list",lAttrs);*/
    sAddAttr := EncapGetVtype ();
    if (e := assoc (sAddAttr, lAttrs))
        sAddMe := cadr (e);
    /* Next look in original common views; SYMBOL may very well have been
     * filtered out by ConsAttrList.
     */
    else if (e := assoc (sAddAttr, alCommonViews))
        sAddMe := cdr (e);
    else
        vdbThrow (1006, "Can't add component.  Select unique %s first.", 
                  sAddAttr);

    /*** HACK_ALERT
      // possibly prepend library name (viewdraw library alias)
      if (vdbCfg.bAddWithLibName)
      sSymbol = substring(sLibCompName,0,lindex(sLibCompName,':'))
      + ":" + sSymbol;
    ***/

    /* Add the thing already */
    /*DEBUG("_Add (%s, %s)\n", sAddMe, lAttrs);*/
    _Add (sAddMe, lAttrs);

}

function AddUnique(this, ev)
{
    /*DEBUG ("selected comp: %s\n", this.sLibCompName);*/

    if (null (this.sLibCompName))
    {
        /* we may have gotten here by unique search instead of */
        /* explicitly selecting a component in the candidates */
        /* dialog.  See if that's the case. */
        l := vllm.CntxExecSearch2 (this.cntx);
        if (length (l) == 1)
            this.sLibCompName = car (l);
        else
            vdbThrow (1007, "Somehow AddUnique() got called when `this.sLibCompName' is nil, and %d candidates exist", length (l));
    }

    DoAdd (this);

}

function AddGeneric(this, ev)
    DoAdd (this);

/*
function AddPart(this, ev)
{
    if (!null (this.sLibCompName))
        AddUnique (this, ev);
    else
        AddGeneric (this, ev);

}
*/

function ConfirmAnnotateAll(this, ev)
{
    /* HACK_ALERT: make sure all groups have been processed */

    /* check if no candidates */
    if (this.iCandidates == 0)
        vdbThrow (1009,
                  "Can't annotate -- no parts match the specified criteria");

    /* check if no common views, other than SYMBOL and _VLLM_LIBRARY_ */
    bFoundCommonAttr := FALSE;
    for (e := this.alCommonViews; !null(e) && !bFoundCommonAttr; e = cdr(e))
        if (!string_eq(caar(e), EncapGetVtype())
            && !string_eq(caar(e), OrgGetVtype()))
            bFoundCommonAttr = TRUE;
    if (!bFoundCommonAttr)
        vdbThrow (1008, "Can't annotate -- no common attributes");

    /* don't let user change the SYMBOL! This could cause vdb2 to annotate
       attributes that don't belong with the symbol on the schematic */
    if (!null (rgn := vlSym.Fetch (this.symVtypeToSearchField,
                                   EncapGetVtype()))
        && !null (e := vlSym.Fetch (this.symVtypeToValueSource,
                                    EncapGetVtype()))
        && e == vdbValueSource.UserSpecified)
        vdbThrow (1010, "Can't annotate -- %s has been changed",
                  EncapGetVtype());

    /* shortcut if not testing for blank values */
    if (vdbCfg.eTestValues == vdbTestValues.No)
        return (FALSE);

    /* loop over values checking for blanks */
    ret := FALSE;
    foreach (sVtype, rgnCmdline; vlSym.Loop (this.symVtypeToSearchField))
        if (string_eq ("", vcRegion.Get (rgnCmdline, vlStringVT)))
        {
            if (!ret)
                ret = "\nThe following attributes have missing values:\n\n";
            ret = ret + "        " + VtypeToAttr (sVtype) + "\n";
        }
    if (ret)
        ret = ret + "\nOK to annotate anyway?\n\n";

    ret;
}

function AnnotateAll(this, ev)
{
    /* HACK_ALERT: only annotate current group for now */

    /* sanity checks performed in ConfirmAnnotateAll */

    lComps := GrpGetComps (this.hGroups);

    /* first exclude qualified views */
    alCommonViews := ExcludeQualifiers (this, this.alCommonViews);

    /* next create attr list from common view list */
    lAttrs := ConsAttrList (this, alCommonViews);
/*
    if (null (lAttrs))
        vdbThrow ("Can't annotate component -- all views excluded.\nUse menu choice \"Config -> Edit config file\" to view configuration options");
*/

    /* Allow overrides through CallOnAnnotate */
    foreach (fn; vscript.list_iter (vdbCfg.lCallOnAnnotate))
        lAttrs = apply (fn, list (lAttrs));
/*
    if (null (lAttrs))
        vdbThrow ("Can't annotate component -- all views excluded through 'CallOnAnnotate option\n");
*/
    /* Perhaps the CallOnAnnotate knew what it was doing and excluded
     * all attrs...
     */
    if (!null (lAttrs))
        /* Annotate, already */
        _Annotate (lComps, lAttrs);

    if (GrpGetNumGroups (this.hGroups) == 1)
        SetMode (this, vdbMode.Idle);
    else
        vdbStatus (this, sprintf ("current group (%d components) processed",
                                  length (lComps)));

}

function ConfirmLoadFromVdraw(this, ev)
/*
    if (modified values)
        "Values have been modified in ViewDatabook, and not back-annotated to Viewdraw.\n\nProceed with load?";
    else
*/
    FALSE;

function LoadFromVdraw(this, ev)
{
    /* This will get done in DisplayGroups(), after ViewDraw responds */
    /*SetMode (this, vdbMode.BackAnnotate);*/
    _Load ();
}

function DisplayGroups(this, lGroups)
{
    MaybeSetMode (this, vdbMode.BackAnnotate);

    /* Only the "vdbgrp.vs" module knows about groups */
    this.hGroups = GrpInitGroups (lGroups);

    /* Create the note tabs.
     * HACK_ALERT: hard-coded table location
     * Note that we can't add a vcNoteTab with no entries to a vcTable, or
     * else we get a core dump.
     */
    this.rgnTabs = vcRegion.Create ("", vcNoteTab.fac, nil);
    if (GrpGetNumGroups(this.hGroups) == 0)
        vcNoteTab.AddEntry (this.rgnTabs, "No groups", 0);
    for (i:=0; i<GrpGetNumGroups(this.hGroups); ++i)
        vcNoteTab.AddEntry (this.rgnTabs,
                            (e := assoc_string_eqi("SYMBOL",
                                         GrpGetAttrList (this.hGroups, i)))
                            ? cadr (e) : i,
                            i);
    vcNoteTab.CallOnSelect (this.rgnTabs,
                            func(i) GrpSetGroup (this.hGroups, this, i););
    vcTable.Set (this.rgnMainTable, 0, 0, this.rgnTabs);

    /* looks like this happens through vcNoteTab.CallOnSelect... */
    /*GrpSetGroup (this, 0);*/

}

function vdbStatus(this, str)
    if (!vcRegion.Destroyed (this.rgnThis))
    {
        win := vcRegion.Window (this.rgnThis);
        if (!null (win))
        {
            vcWin.ClearStatus (win);
            vcWin.AddStatus (win, str);
        }
    }

function RereadConfigFile (this)
{
    vdbCfgReadConfigFile ();
    vdbStatus (this, "Reread config file.");
    if (isbound (`_ResetConfig, current_package ()))
        _ResetConfig ();
}

function EnableCmds(this)
{
    bDoRefresh := !null (win := vcRegion.Window (this.rgnThis));

    GrpEnableCmds (this.hGroups, this);

    /* config file-related */
    vcCmd.Enable (cmdCfgEdit, !null (vdbCfgGetFilename ()));
    vcCmd.Enable (cmdCfgReread, !null (vdbCfgGetFilename ()));

    /*
     * Mode-related stuff.
     *
     * Disable both commands and the button regions which invoke them.
     * Don't disable the whole button row, because the user still wants to
     * use the Load button.
     *
     * HACK_ALERT: hard-coded button numbers
     */
    bEnabled := (this.eMode != vdbMode.Idle);
    function EnableButn(i)
        vcRegion.Enable (vcButnRow.Get (this.rgnButnRow, i),
                         bEnabled, bDoRefresh);
    vcCmd.Enable (cmdAddGeneric, bEnabled);
    EnableButn (0);
    vcCmd.Enable (cmdSearchExec, bEnabled);
    EnableButn (1);
    vcCmd.Enable (cmdSearchClear, bEnabled);
    EnableButn (2);
    vcCmd.Enable (cmdListCandidates, bEnabled);
    EnableButn (3);
    vcRegion.Enable (this.rgnSearchArea, bEnabled, bDoRefresh);
    if (!bEnabled)
        /*vcRegion.SetFocus (this.rgnButnRow, this.rgnButnRow);*/
        vcButnRow.SetDefault (this.rgnButnRow, 4);

    vcCmd.Enable (cmdAddMode, bEnabled || !null(this.hGroups));

    if (bDoRefresh)
        vcWin.UpdateMenus (win);

} /* EnableCmds */

function ShowIdleMessage(this)
    vdbStatus (this, sprintf("Select Search->By%s or press Load",
                             OrgGetLabel()));

function _Initial(this, e)
{
    EnableCmds (this);
    if (null (this.sCategory))
        ShowIdleMessage (this);
}

/*
 * Commands.
 */
function CmdSetHelp (cmd, sHelp)
{
    vcCmd.SetHelp (cmd, sHelp);
    vcCmd.SetTip (cmd, sHelp);
}

cmdNoop :=
    vcWv.Cmd (fac, func(d,e)
              {
                  vcWin.ClearStatus (vcEvent.Window (e));
                  vcWin.AddStatus (vcEvent.Window (e), "No op.");
              });
cmdSearchExec :=
    vcWv.Cmd (fac, SearchButtonChangeCriteria, "search_exec");
CmdSetHelp (cmdSearchExec, sprintf("Search%s for matching components",
                                   (vdbCfg.eOrg == vdbOrganized.ByLibrary)
                                   ? " the library" : ""));
cmdSearchClear :=
    vcWv.Cmd (fac, SearchButtonClear, "search_clear");
CmdSetHelp (cmdSearchClear, "Clear all search values");
cmdListCandidates :=
    vcWv.Cmd (fac, UniqueCompSelected,
              "candidates", "Candidate Components",
              vcWv.Param ("", vscmVT, vcWv.Dynamic, GetCandidatesData,
                          vdbResults.fac));
CmdSetHelp (cmdListCandidates, "List the matching components");
cmdAddGeneric :=
    vcWv.Cmd (fac, AddGeneric, "generic");
CmdSetHelp (cmdAddGeneric,
            "Add a component with only the displayed attributes");
cmdAddUnique :=
    vcWv.Cmd (fac, AddUnique, "unique");
CmdSetHelp (cmdAddUnique, "Add a component with all the displayed attributes");
/*
cmdAddPart :=
    vcWv.Cmd (fac, AddPart, "comp");
*/
cmdAnnotate :=
    vcWv.CmdWithConfirm (fac, AnnotateAll, ConfirmAnnotateAll,
                         FALSE, "annotate");
CmdSetHelp (cmdAnnotate,
            "Write modified values back to " + EncapGetToolName ());
/*
cmdDisplayViews :=
    vcWv.Cmd (fac, func(d,e) DEBUG ("Views button\n");, "views");
*/
cmdSearchAcrossCategories :=
    vcWv.Cmd (fac, SearchAcrossCategories, "searchall");
CmdSetHelp (cmdSearchAcrossCategories,
            "Search for components across all libraries");
cmdSearchByCategory :=
    vcWv.Cmd (fac, SearchByCategory, "searchlib",
              "Select "+OrgGetLabel(),
              vcWv.Param ("", vscmVT, vcWv.Dynamic,
                          GetCategories,
                          vcPickEdit.fac,
                          height <- 7));
CmdSetHelp (cmdSearchByCategory,
            "Search for components "+
            ((vdbCfg.eOrg == vdbOrganized.ByLibrary)
             ? "within a given library"
             : ("with a given "+OrgGetLabel())));
cmdLoadFromVdraw :=
    vcWv.CmdWithConfirm (fac, LoadFromVdraw, ConfirmLoadFromVdraw,
                         FALSE, "vdload",
                         "Load component values from ViewDraw");
CmdSetHelp (cmdLoadFromVdraw,
            "Load attributes from selected components");
cmdResetToLoadedValues :=
    vcWv.Cmd (fac,
              func(this, ev) GrpReset (this.hGroups, this);,
              "reset");
CmdSetHelp (cmdResetToLoadedValues,
            "Reset attributes to loaded values");
/* Next/prev now taken care of by tabs.
cmdNextGroup :=
    vcWv.Cmd (fac, GrpNextGroup, "next");
CmdSetHelp (cmdNextGroup, "Process next group of components");
vcCmd.Enable (cmdNextGroup, FALSE);
cmdPrevGroup :=
   vcWv.Cmd (fac, GrpPrevGroup, "prev");
CmdSetHelp (cmdPrevGroup, "Process previous group of components");
vcCmd.Enable (cmdPrevGroup, FALSE);
*/
cmdAddMode :=
   vcWv.Cmd (fac, AddMode, "add_mode");
CmdSetHelp (cmdAddMode, "Change \"Annotate\" button to \"Add\"");
cmdCfgReread :=
   vcWv.Cmd (fac, func(this,e) RereadConfigFile (this);, "reread");
CmdSetHelp (cmdCfgReread, "Reread configuration file");
cmdCfgEdit :=
   vcWv.Cmd (fac,
             func(this,e)
             {
                 fname := vdbCfgGetFilename ();
                 if (null (fname))
                     vdbThrow (1011, "vdbum.scm not found in WDIR");
                 vcWin.TextEdit (vcEvent.Window (e),
                                 fname, nil,
                                 func(args...) RereadConfigFile (this);,
                                 FALSE, FALSE);
             }, "config_edit");
CmdSetHelp (cmdCfgEdit, "Edit configuration file");

/* HACK_ALERT: hard-coded list of view types */
/*
lPossibleViewNames :=
    list ("SYMBOL", "PKG_TYPE", "VHDL", "VERILOG");
define_enum ("ViewTypesVT", lPossibleViewNames);
cmdRequiredViews :=
    vcWv.Cmd (fac, SearchSetRequiredViews, "required_views",
              "Minimum Required Views",
              vcWv.Param ("", vscmVT, vcWv.Dynamic,
                          func (this) vdbCfg.alRequiredViews;,
                          vdbChecklist.fac,
                          data <- lPossibleViewNames));
*/

/* These are hacks to prevent double-clicks from
   executing the default button in the vcButnRow. */
cmdNothing := vcWv.Cmd (vcWin.fac, func(args...););
vcBind.Set (vcWin.bindings, '\leftdbl', cmdNothing);
cmdDefaultAction :=
    vcWv.Cmd (vcWin.fac, func(win, ev) vcWin.DefaultAction(win, ev););
vcBind.Set (vcPickEdit.bindings, '\leftdbl', cmdDefaultAction);
vcBind.Set (vcPicklist.bindings, '\leftdbl', cmdDefaultAction);

/* Hack?  This is the way vcPref implements its "Apply All" button...
 */
function DisplayTips(this, e, bTurnOn)
{
    lPrefs := (bTurnOn) ? list(tip_delay <- 200) : list(tip_delay <- -1);
    foreach (rgn; vcRegion.Children (this.rgnThis, TRUE))
        if (vcRegion.Fac (rgn) == vcButton.fac)
            vcRegion.PrefSet (rgn, lPrefs);
}
cmdDisplayTips :=
    vcWv.Cmd (fac, DisplayTips, "display_tips", "Display Button Tips",
              vcWv.Param ("Display tips", vlYesNoVT, vcWv.Sticky, TRUE));

/*
 * Load bindings, menus, and user customizations.
 *
 * The bt.vs file binds commands to user-interface actions.
 * The mn.vs file binds menus to commands.
 * The us.vs file contains user customizations, and may not exist.
 */
facname := vcFac.Name (fac);
load (facname + "bt.vs");
load (facname + "mn.vs");

/*
 * Disable all tips, if preference off.
 */
if (! vdbCfg.bDisplayTips)
    vlPref.Setval (vcButton.prefs, "tip_delay", -1);

