/* declare global variables */
declare pick_list_table;
declare tech_string;


function make_tech_list() {
  
    declare filename, techs;
    declare cmd, ignore, path, alias;

    function append_to_list( string file ) {
        declare n_rows, n_cols, r, c, border, region;
        
        file = caddr (vscript.vsParse (file));       
        if( !test.IsInPicklist( techs, file ))
            vcPicklist.Add(techs, file, file );
    }
 

    function search_primary_dir() {
    
    declare filename;

    if( primary_path != nil ) {
        filename = vscript.vsAbsPath (primary_path) + "/*.sml";
        vscript.vsLoop(filename, vscript.vsFILE, append_to_list); }
    } /* end of search_primary_dir */
           
    function search_vdraw_dir() {

        declare path_l, alias_l, path, alias, filename;

        path_l = vdraw_path;
        alias_l = vdraw_alias;
        for(; !null( path_l ); path_l = cdr( path_l )) {
            path =  car( path_l );
            alias = car( alias_l );
            alias_l = cdr( alias_l );
            filename = vscript.vsAbsPath (path) + "/*.sml";
            foreach (file;  vscript.TraverseDir( filename,
                     vscript.vsFILE)) {
                file := caddr (vscript.vsParse (file));
                if( alias != nil ) file := alias  + ":" + file;
                append_to_list( file );
            }
        }
    } /* end of search_vdraw_dir */
 
  
    function search_wdir() {
    /* get a list of sml files from WDIR */

    foreach (path; vscript.env_path("WDIR"))
        {
            filename = vscript.vsAbsPath (path) + "/*.sml";
            vscript.vsLoop(filename, vscript.vsFILE, append_to_list);
        }
    } /* end of search_wdir */

 
    /* create pick_list region */
   
    techs = vcRegion.Create1("Exclusive Scroll", vcPicklist.fac, nil,
                             list(columns <- 1));
    search_primary_dir();
    search_vdraw_dir();
    search_wdir();
    tech_picklist := vcPicklist.Scroll("tech", techs, 5, 2, 10);
    vcPicklist.Notify ( techs, func( tech, on ) if (on) { 
                        vcCmdline.Set( tech_string, tech );}); 
    return( tech_picklist );

}
function _Create(name, region) {

    pick_list_table = make_tech_list();
    tech_string = vcRegion.Create ("tech", vcCmdline.fac, v2.current_tech,
                                max_width <- 10);

    table := vcTable.Make ("", 2, 1,
                           tech_string, pick_list_table );
 
    vcRegion.AddChild (region, table);
    table;
} /* function _Create */

function _Get(table, region, ts) vcRegion.Get(vcTable.Get (table, 0, 0),ts);


