/* declare global variables */
declare pick_list_table;
declare outdir_string;

function make_outdir_list() {

    declare alias_l, alias, outdirs;

    function append_to_list( string item ) { 
       declare name;
       
       name = item + ":";
       if( !test.IsInPicklist( outdirs, name ))
            vcPicklist.Add(outdirs, name, name );
    }

    outdirs = vcRegion.Create1("Exclusive Scroll", vcPicklist.fac, nil,
                             list(columns <- 1));
    vcPicklist.Add(outdirs, ":", ":" );
    alias_l = writable_alias;
    for(; !null( alias_l ); alias_l = cdr( alias_l )) {
          alias =  car( alias_l );
          append_to_list( alias );
    }

    outdir_picklist := vcPicklist.Scroll("outdir", outdirs, 5, 2, 10);
    vcPicklist.Notify ( outdirs, func( data, on ) if (on) {
                        vcCmdline.Set( outdir_string, data );});
    outdir_picklist;
}


function _Create(name, region) {

    pick_list_table = make_outdir_list();
    outdir_string = vcRegion.Create ("outdir", vcCmdline.fac, v2.current_outdir,
                                max_width <- 10);

    table := vcTable.Make ("", 2, 1,
                           outdir_string, pick_list_table );

    vcRegion.AddChild (region, table);
    table;
} /* function _Create */

function _Get(table, region, ts) vcRegion.Get(vcTable.Get (table, 0, 0),ts);
