/* This file contains the ViewFPGA menus */

/* File menu */
m_main_file := vcWv.MakeMenu ("m_main_file",
   list ("Specify schematic", c_file_sch));

if (!menuIsPLDonly ())
    vcMenu.AppendEntry (m_main_file, "Specify VHDL", c_file_vhdl);
if (menuHasPLD ()) {
   vcMenu.AppendEntry (m_main_file, "Specify ABEL", c_file_abel);
   vcMenu.AppendEntry (m_main_file, "Specify JEDEC", c_file_jed); }
vcMenu.AppendEntry (m_main_file, "Edit selected file", c_file_edit);


/* Create menu */
m_main_cre := vcWv.MakeMenu  ("m_main_cre",
   list ("Symbol...", c_cre_sym),
   list ("Functional model", c_cre_func));

menuSubcreate ("cre", vfpgaMenuMask.Actel,  m_main_cre, "Actel", list (
   list ("WIR file", c_act_wir),
   list ("Validator report", c_act_val),
   list ("Pin assignments...", c_act_pin),
   list ("Routed design", c_act_routed)));

menuSubcreate ("cre", vfpgaMenuMask.Altera, m_main_cre, "Altera", list (
   list ("WIR file", c_alt_wir),
   list ("Routed design", c_alt_routed)));

menuSubcreate ("cre", vfpgaMenuMask.PLD,    m_main_cre, "PLD", list (
   list ("Partitioning schematic", c_cre_part),
   list ("JEDEC", c_cre_jedec),
   list ("JEDEC and timing model", c_cre_timing)));

menuSubcreate ("cre", vfpgaMenuMask.Xilinx, m_main_cre, "Xilinx", list (
   list ("WIR file", c_xil_wir),
   list ("Routed 2k/3k design", c_xil23_routed),
   list ("Routed 4k design...", c_xil4_routed)));

if (menuHasFPGA ())
   vcMenu.AppendEntry (m_main_cre, "FPGA WIR file", c_cre_wir);


/* Option menu */
m_main_options := vcWv.MakeMenu  ("m_main_options",
   list ("Global options", vcWin.PrefsCmd));

if (menuHasPLD ())
   vcMenu.AppendEntry (m_main_options, "ABEL compiler", c_opt_ahdl2pla);

if (!menuIsPLDonly ())
   vcMenu.AppendEntry (m_main_options, "VHDL analyzer", c_opt_vhdl);

menuSubcreate ("opt", vfpgaMenuMask.Actel,  m_main_options, "Actel", list (
   list ("Synthesis", c_opt_actsyn),
   list ("Package", c_opt_actpkg),
   list ("Implementation", c_opt_actimp)));

menuSubcreate ("opt", vfpgaMenuMask.Altera, m_main_options, "Altera", list (
   list ("Synthesis", c_opt_altsyn),
   list ("Optimization", c_opt_altopt),
   list ("Implementation", c_opt_altimp)));

menuSubcreate ("opt", vfpgaMenuMask.PLD, m_main_options, "PLD", list (
   list ("PLA optimizer", c_opt_plaopt),
   list ("PLD partitioner", c_opt_part),
   list ("Fitter (pin assignment)", c_opt_fit),
   list ("PLD device selector", c_opt_devsel),
   list ("JEDEC writer", c_opt_fuseasm),
   list ("PLD timing modeller", c_opt_j2vhdl)));

menuSubcreate ("opt", vfpgaMenuMask.Xilinx, m_main_options, "Xilinx", list (
   list ("Synthesis", c_opt_xilsyn),
   list ("Device", c_opt_xildev),
   list ("2k/3k implementation", c_opt_xil23apr),
   list ("Bitstream...", c_opt_xilbits)));

if (menuHasFPGA ())
   vcMenu.AppendEntry (m_main_options, "Synthesis", c_opt_synth);


/* Utility menu */
m_main_util := vcWv.MakeMenu  ("m_main_util");

menuSubcreate ("util", vfpgaMenuMask.Actel, m_main_util, "Actel", list (
   list ("Copy tutorial files", c_util_act2tut),
   list ("Delete intermediate files", c_util_actdel),
   list ("Create partlist file", c_util_actptl)));

menuSubcreate ("util", vfpgaMenuMask.Altera, m_main_util, "Altera", list (
   list ("Copy tutorial files", c_util_alttut),
   list ("Delete intermediate files", c_util_altdel)));

menuSubcreate ("util", vfpgaMenuMask.PLD, m_main_util, "PLD", list (
   list ("Copy tutorial files", c_util_diotut),
   list ("Delete intermediate files", c_util_delint),
   list ("Create logical schematic", c_util_diosch),
   list ("Show PLD pinouts", c_util_pldpins),
   list ("Programmer window", c_util_burndev)));

menuSubcreate ("util", vfpgaMenuMask.Xilinx, m_main_util, "Xilinx", list (
   list ("Copy tutorial files", c_util_x3tut),
   list ("Delete intermediate files", c_util_xildel),
   list ("Create partlist file", c_util_xilptl)));

if (menuIsFPGAonly ())
   vcMenu.AppendEntry (m_main_util, "Delete intermediate files",c_util_fpgaint);

/* Main menu */
vcFac.SetMenus (fac, vcWv.MakeMenu  ("m_main",
   vcWin.RedSquareEntry,
   list ("File", m_main_file),
   list ("Create", m_main_cre),
   list ("Options", m_main_options),
   list ("Utilities", m_main_util)));
