/*  vsimIcon.vs -- substitute for vcIcon, since, the background color cannot set
 *  in vcIcon.
 */


function _Create (data, rgn)
{
    this := struct {
	icon;
	region;
	fg_color;
	bg_color
    };

    this.icon		= list_ref (data, 0);
    this.fg_color	= list_ref (data, 1);
    this.bg_color	= list_ref (data, 2);
    r := vcRegion.Create (vcRegion.Name (rgn) +"icon", vcIcon.fac, this.icon);
    this.region = r;
    vcRegion.Foreground (r, this.fg_color, FALSE);
    vcRegion.Background (r, this.bg_color, FALSE);
    vcRegion.AddChild (rgn, r);
    this;
}


function _Refresh (this, ev)
{
   vcRegion.Foreground (this.region, this.fg_color, FALSE);
   vcRegion.Background (this.region, this.bg_color, FALSE);
   vcRegion.Refresh    (this.region, vcRegion.Area (this.region));
}


function _Get (this, region, desired_type)
{
    mylist := list (this.icon, this.fg_color, this.bg_color);
    convert (desired_type, mylist);
}
