/*
 * $Revision: 1.6.8.1 $
 *
 * This implements the dev feed which sets the form feed on/off for
 * certain devices.
 */
package vspfeed (create_devfeed, apply_changes) {

FeedOnStr := "FEED ON";
FeedOffStr := "FEED OFF";
declare feed_on_lab, feed_off_lab;
declare feed_ovly;
declare cur_feed_ovly;

function change_feed () {

        cur_feed_ovly = ((cur_feed_ovly == feed_on_lab) ? feed_off_lab : 
                        feed_on_lab);

        vcOverlay.SetCurrent (feed_ovly, cur_feed_ovly);
        set_options_modified ();
}

function apply_changes () {
        if (cur_feed_ovly == feed_on_lab)
                fac_pack.sp_sapopt (FeedOnStr);
        else
                fac_pack.sp_sapopt (FeedOffStr);
}

function create_devfeed () {
        /* Create overlay labels */        
        feed_on_lab = vcLabel.ButtonCreate ("FeedOn.but", FeedOnStr, 
                                        change_feed, list (macro_on <- FALSE));

        feed_off_lab = vcLabel.ButtonCreate("FeedOff.but", FeedOffStr, 
                                        change_feed, list (macro_on <- FALSE));

        /* Find out current state and set it */
        feed_state := fac_pack.get_def_feed ();

        if (feed_state)
                cur_feed_ovly = feed_on_lab;
        else
                cur_feed_ovly = feed_off_lab;

        ovly_lst := create_toggle ("feed", feed_on_lab, feed_off_lab, 
                        cur_feed_ovly);

        feed_ovly = car (ovly_lst);

        feed_reg := cadr (ovly_lst);
        if (!fac_pack.get_dev_feedable ())
                vcRegion.Enable (feed_reg, FALSE, TRUE);

        return (feed_reg);
}

}
