/* <<<<Menus>>>> */

FileMenu := vcWv.MakeMenu("File",
                           list("Open",    FileOpenCmd),
                           list("Read",    FileReadCmd),
                           list("ReadStream", FileReadStreamCmd),
                           vcWv.Separator(),
                           list("Update",  FileUpdateCmd),
                           list("NUpdate", FileNUpdateCmd),
                           list("CancelUpdate", FileCancelUpdateCmd),
                           vcWv.Separator(),
                           list("Write",   FileWriteCmd),
                           list("WriteTo", FileWriteToCmd),
                           vcWv.Separator(),
                           list("RereadCfg", FileRereadCfgCmd));

ViewMenu := vcWv.MakeMenu("View",
                           list("Refresh", ViewRefreshCmd),
                           list("Full",    ViewFullCmd),
                           list("Zoom",    ViewZoomMenuCmd),
                           list("In",      ViewInCmd),
                           list("Out",     ViewOutCmd),
                           list("Pan",     ViewPanMenuCmd),
                           list("Scroll",  ViewScrollMenuCmd),
                           list("Range",   ViewRangeCmd),
                           vcWv.Separator(),
                           list("Save",    ViewSaveCmd),
                           list("Restore", ViewRestoreCmd));

EditMenu := vcWv.MakeMenu("Edit",
                           list("CreateSignal", EditCreateSignalCmd),
                           vcWv.Separator(),
                           list("InsertTime", EditInsertTimeCmd),
                           list("SetValue", EditSetValueCmd),
                           list("Clear", EditClearCmd),
                           list("Delete", EditDeleteCmd),
                           list("Cut", EditCutCmd),
                           list("Copy", EditCopyCmd),
                           list("Paste", EditPasteCmd),
                           list("Substitute", EditSubstCmd),
                           vcWv.Separator(),
                           list("Repeat", EditRepeatCmd),
                           list("Replace", EditReplaceCmd),
                           vcWv.Separator(),
                           list("TimeLimit", EditTimeLimitCmd),
                           list("TimeStep", EditTimeStepCmd));

ChangeSignalMenu := vcWv.MakeMenu("Signal",
                                   list("Color",  ChangeSignalColorCmd),
                                   list("Symbol", ChangeSignalSymbolCmd),
                                   list("Name",   ChangeSignalNameCmd),
                                   list("Radix",  ChangeSignalRadixCmd));

ChangeAxisMenu := vcWv.MakeMenu("Axis",
                                 list("Type",      ChangeAxisTypeCmd),
                                 list("Notation",  ChangeAxisNotationCmd),
                                 list("Label",     ChangeAxisLabelCmd),
                                 list("Grid",      ChangeAxisGridCmd),
                                 list("GridSpace", ChangeAxisGridSpaceCmd),
                                 list("Side",      ChangeAxisSideCmd),
                                 list("Symbols",   ChangeAxisSymbolsCmd));

ChangeValuesMenu := vcWv.MakeMenu("Values",
                                 list("Notation",  ChangeValuesNotationCmd),
                                 list("NumDigits", ChangeValuesNumDigitsCmd));

ChangeDisplayWidthsMenu := vcWv.MakeMenu("Widths",
                                          vcWv.Pin(),
                                 list("Names",  ChangeDisplayWidthsNamesCmd),
                                 list("Values", ChangeDisplayWidthsValuesCmd),
                                 list("V-Axis", ChangeDisplayWidthsVAxisCmd),
                                 list("H-Axis", ChangeDisplayWidthsHAxisCmd));

ChangeDisplayMenu := vcWv.MakeMenu("Display",
                                    list("Info",     ChangeDisplayInfoCmd),
                                    list("Values",   ChangeDisplayValuesCmd),
                                    list("Markers",  ChangeDisplayMarkersCmd),
                                    list("Symbols",  ChangeDisplaySymbolsCmd),
                                    list("NSymbols", ChangeDisplayNSymbolsCmd),
                                    list("IncrSymbol", ChangeDisplayISymbolCmd),
                                    list("IncrColor", ChangeDisplayIColorCmd),
                                    list("Lines",    ChangeDisplayLinesCmd),
                                    list("Widths",   ChangeDisplayWidthsMenu),
                          list("RegionBndry", ChangeDisplayRegionBoundaryCmd));

ChangeTextMenu := vcWv.MakeMenu("Text",
                                 vcWv.Pin(),
                                 list("Create", ChangeTextCreateCmd),
                                 list("Move",   ChangeTextMoveMenuCmd),
                                 list("String", ChangeTextStringCmd),
                                 list("Color",  ChangeTextColorCmd),
                                 list("Origin", ChangeTextOriginCmd),
                                 list("Size",   ChangeTextSizeCmd),
                                 list("Delete", ChangeTextDeleteCmd));

ChangeMenu := vcWv.MakeMenu("Change",
                             list("Signal",     ChangeSignalMenu),
                             list("Axis",       ChangeAxisMenu),
                             list("Values",     ChangeValuesMenu),
                             list("Display",    ChangeDisplayMenu),
                             list("Text",       ChangeTextMenu),
                             vcWv.Separator(),
                             list("SnapMode",   ChangeSnapModeCmd),
                             list("Annotation", ChangeAnnotationCmd));

SelectMenu := vcWv.MakeMenu("Select",
                             list("Signal",    SelectSignalCmd),
                             list("Text",      SelectTextCmd),
                             vcWv.Separator(),
                             list("UnselSig",  UnSelectSignalCmd),
                             list("UnselText", UnSelectTextCmd));

SignalDigiOpsMenu := vcWv.MakeMenu("Digi-Ops",
                                    vcWv.Pin(),
                                    list("Copy",       SignalCopyCmd),
                                    list("Invert",     SignalInvertCmd),
                                    list("Bus",        SignalBusCmd),
                                    list("Expand",     SignalExpandCmd),
                                    list("TShift",     SignalTShiftCmd),
                                    list("TScale",     SignalTScaleCmd));

SignalScrollMenu := vcWv.MakeMenu("Scroll",
                                   vcWv.Pin(),
                                   list("Home",      HomeCmd),
                                   list("Page Up",   PgUpCmd),
                                   list("Up",        UpCmd),
                                   list("Down",      DownCmd),
                                   list("Page Down", PgDnCmd),
                                   list("End",       EndCmd));

SignalMenu := vcWv.MakeMenu("Signal",
                             list("Show",       SignalShowMenuCmd),
                             list("Hide",       SignalHideCmd),
                             list("Delete",     SignalDeleteCmd),
                             list("Scroll",     SignalScrollMenu),
                             list("Move",       SignalMoveCmd),
                             list("FromSch",    FromSchematicCmd),
                             vcWv.Separator(),
                             list("ToAxis",     SignalToAxisCmd),
                             list("FromAxis",   SignalFromAxisCmd),
                             list("ChangeAxis", SignalChangeAxisCmd),
                             vcWv.Separator(),
                             list("Math",       SignalMathExprCmd),
                             list("Logic",      SignalLogicCmd),
                             list("Digi-Ops",   SignalDigiOpsMenu),
                             vcWv.Separator(),
                             list("Merge",      SignalMergeCmd),
                             list("FFT",        SignalFFTCmd));
/*
                             list("Math",       SignalMathCmd),
*/

AxisMenu := vcWv.MakeMenu("Axis",
                           list("Add",        AxisAddCmd),
                           list("Split",      AxisSplitCmd),
                           list("Join",       AxisJoinCmd),
                           list("X-Variable", AxisXVariableMenuCmd),
                           list("Remove",     AxisRemoveCmd));

MainMenu := vcWv.MakeMenu("VIEWtrace",
                           vcWin.RedSquareEntry,
                           list("File",   FileMenu),
                           list("View",   ViewMenu),
                           list("Edit",   EditMenu),
                           list("Change", ChangeMenu),
                           list("Signal", SignalMenu),
                           list("Axis",   AxisMenu),
                           list("Select", SelectMenu));

vcFac.SetMenus(fac, MainMenu);

/* this popup is relatively stupid */
PopupMenu := vcWv.MakeMenu("Viewtrace popup",
                            vcWv.Pin(),
                            list("Set Point", SetPointWRTMouseCmd),
                            list("Set Mark",  SetMarkWRTMouseCmd),
                            list("Exchange",  ExchangeCmd),
                            vcWv.Separator(),
                            list("Info",      ChangeDisplayInfoCmd),
                            list("Values",    ChangeDisplayValuesCmd),
                            vcWv.Separator(),
                            list("CreateSignal", EditCreateSignalCmd),
                            list("SetValue", EditSetValueCmd));

PopupMenuCmd := vcWv.Cmd(fac, func(d, e)
                         vcMenuPop.Create(PopupMenu, e);, "PopUp");
vcCmd.EnableMacro(PopupMenuCmd, vlOnOff.Off);
