/* 
 * $Id: dropper.vs,v 1.2.1.1 1995/01/24 21:54:46 cway Stab $
 *
 * drag&drop demo: dropsite facility
 */

function _Create (d, r) {
    c := vcRegion.Create ("color", vcColor.fac, d, 
                      size <- vgSize.Create (100, 100, 100, 100, 100, 100));
    b := vcRegion.Create ("", vcBorder.fac, c);
    vcRegion.AddChild (r, b);
    struct {color = d; border = b};
}

/* The _QueryDrop method serves two purposes.
 * The dropsite can determine whether it wants to accept the drop.
 * It could, for example, check the type of the dragdata, 
 * or check the coordinates in the event.
 *
 * Secondly, it can visually indicate a drag-over. This is done
 * here through highlighting.
 */
function _QueryDrop (d, ev, data, onoff)
    if (typeof (data) == dragdemoVT) {
        if (onoff)
            vcRegion.Highlight (d.border);
        else
           vcRegion.Unhighlight (d.border);
        vcWvDropAccept.YesAll;
    } else
        vcWvDropAccept.No;


/* This is called when the drop happens. It is only called
 * if _QueryDrop has agreed to accept the drop.
 */
function _CompleteDrop (d, ev, data) 
    printf ("Dropped %s on %s\n", data, convert (vlStringVT, d.color));






