/*
 *  $Revision: 1.4.6.1 $
 *
 *  Font demonstration.
 *
 *  Copyright (c) 1992 by Viewlogic Systems, Inc.
 */

raster := vcTable.Create ("raster", 8, 4);

declare font, str, label;

for (i := 0; i < 32; ++i) {
    font := convert (vgFontVT, i);
    str := convert (vlStringVT, font);
    label := vcRegion.Create (str, vcLabel.fac, str);
    vcRegion.Font (label, font);
    vcTable.Add (raster, label);
} /* for */

vcTable.Row (raster, -1, vcTable.Border.Invisible, 0, 5, 10,
             vgAlign.LowerLeft);
vcTable.Col (raster, -1, vcTable.Border.Invisible, 0, 5, 10,
             vgAlign.LowerLeft);

canvas := vcRegion.Create ("stroke", vcCanvas.fac, nil,
                           size <- vgSize.Create (400, 120, 200, 60,
                                                  800, 240));

function floor(x) convert (integer, x);

function refresh(event) {
    vp := vcRegion.Viewport (canvas, vgRect.Create (0, 0, 400, 120), 0);
    for (i := 0; i < 11; ++i) {
        font := convert (vgStkVT, i);
        str := convert (vlStringVT, font);
        vgU.StkFont (vp, font);
        vgU.StkSize (vp, 20, 20);
        vgU.StkDraw (vp, str, vgAlign.LowerLeft, 200*(i%2), 20*floor (i/2));
    } /* for */
} /* function refresh */
vcCanvas.RefreshProc (canvas, refresh);

t := vcTable.Make ("Fonts", 4, 1,
                   vcRegion.Create ("", vcLabel.fac, "Raster Fonts"),
                   raster,
                   vcRegion.Create ("", vcLabel.fac, "Stroke Fonts"),
                   canvas);

vcWin.Create (t, vcWin.NoStatus + vcWin.NoBindings);
