/*
 *  $Revision: 1.5.6.1 $
 *
 *  Copyright (c) 1992 by Viewlogic Systems, Inc.
 */

/*
 * This demonstrates how to create a region to display an icon.  The
 * particular icon is an Escher knot, and it is in the file escher.xbm.  Icons
 * are created using the X bitmap editor "bitmap".  Simply type "bitmap
 * icon_name", optionally followed by a size specification like 10x20.  If you
 * are editing an existing icon file, you should not specify a size.  The
 * operation of the program is very simple.
 *
 * Note that the bitmap files are actually valid C source code, and can be
 * #included in your C source file.  This is not recommended practice for
 * Viewlogic developers, since the resulting code will not be portable.  It is
 * also fairly efficient to read in the bitmap files at runtime.
 *
 * Icon filenames should have an extension of ".xbm", as per existing
 * convention.  We will need to translate these icons to MS Windows format at
 * some point, and they will have a different extension.  So just specify
 * the name without the extension in your code, and the underlying software
 * will tack on the correct extension.
 */

/*
 * The actual code below is simple.  It creates an Icon region giving it
 * the data object "escher", which the icon facility interprets as a
 * filename, searches for it in WDIR, and loads it.
 */
vcWin.Create (vcRegion.Create1 ("Escher", vcIcon.fac, "escher", 
                                list (macro_on <- TRUE)),
              vcWin.NoStatus + vcWin.NoCmdline + vcWin.NoMenus);
