/*
 *  $Revision: 1.1.5.1 $
 *
 *  Using the vcMargin facility to add spacing around regions.
 *
 *  Copyright (c) 1993 by Viewlogic Systems, Inc.
 */

/*
 * Though this demo highlights the vcMargin facility, note that the demo.vs
 * code actually uses it around the vcStatText region.
 */

/*
 * Wrap the region around a sized fillstyle box.
 * Override just the `bottom_margin' preference.
 */
rgn := vcRegion.Create ("blah", vcFstyle.fac, vgFill.Grey50,
                        size <- vgSize.Create (100,100,100,100,100,100));
margin := vcRegion.Create ("Margin 1", vcMargin.fac, rgn,
                           bottom_margin <- 10);
vcWin.Create (margin, vcWin.NoBindings + vcWin.NoStatus);


/*
 * Wrap the region around a sized fillstyle box.
 * Increase the margin size through the `margin_size' preference.
 */
rgn := vcRegion.Create ("blah", vcFstyle.fac, vgFill.Grey50,
                        size <- vgSize.Create (100,100,100,100,100,100));
margin := vcRegion.Create ("Margin 2", vcMargin.fac, rgn,
                           margin_size <- 10);
vcWin.Create (margin, vcWin.NoBindings + vcWin.NoStatus);
