/* 
 * 
 * Toggle button and radio box demonstration
 */


/* create the tables & stuff */

biggertab := vcTable.Create ("Toggle Buttons", 2, 1);
bigtab := vcTable.Create ("bigtab ", 1, 2);
lefttab := vcTable.Create ("left table", 3, 1);
righttab := vcTable.Create ("right table", 2, 1);

vcTable.Row (biggertab, vcTable.All, vcTable.Border.Visible, 1, 1, 1,
       vgAlign.MiddleCenter);
vcTable.Col (bigtab, vcTable.All, vcTable.Border.Visible, 3, 3, 3, 
       vgAlign.UpperLeft);
vcTable.Row (bigtab, vcTable.All, vcTable.Border.Visible, 3, 3, 3, 
       vgAlign.UpperLeft);
vcTable.Row (lefttab, vcTable.All, vcTable.Border.Visible, 3, 3, 3, 
       vgAlign.UpperLeft);
vcTable.Row (righttab, vcTable.All, vcTable.Border.Visible, 3, 3, 3, 
       vgAlign.UpperLeft);
vcTable.Col (lefttab, vcTable.All, vcTable.Border.Visible, 3, 3, 3, 
       vgAlign.UpperLeft);
vcTable.Col (righttab, vcTable.All, vcTable.Border.Visible, 3, 3, 3, 
       vgAlign.UpperLeft);

thecolor := vgColor.Green;
show_box := TRUE;
show_circle := FALSE;

canvas := vcRegion.Create ("canvas", vcCanvas.fac, nil, size <- 
           vgSize.Create(200, 200, 100, 100, 800, 800));
vcCanvas.RefreshProc (canvas, func (ev) {
   vp := vcRegion.Viewport (canvas, vgRect.Create (0, 0, 100, 100), 
                                        vgU.OneToOne);
   vgU.Color (vp, vgColor.Black);
   vgU.EraseRect (vp, vgRect.Create (0, 0, 100, 100));
   vgU.Color (vp, thecolor);
   if (show_box)
      vgU.Box (vp, vgRect.Create (10, 30, 40, 70));
   if (show_circle)
      vgU.Circle (vp, 75, 50, 20);
});

radiotext := vcRegion.Create ("radio text", vcStaticText.fac, "Radio Box");
vals := list(list("green",   vgColor.Green),
             list("cyan",    vgColor.Cyan),
             list("red",     vgColor.Red),
             list("yellow",  vgColor.Yellow),
             list("magenta", vgColor.Magenta),
             list("blue",   vgColor.Blue));

radio := vcRegion.Create ("radio", vcRadioBox.fac, vgColor.Green, 
               data <- vals, macro_on <- TRUE);
vcTable.Add (righttab, radiotext);
vcTable.Add (righttab, radio);

vcRadioBox.NotifyOnChange (radio, func (ev, val) {
             thecolor = val;
             vcRegion.Refresh (canvas, vcRegion.Area (canvas));});

function act (ev, val) {
                     show_box = val;
                     vcRegion.Refresh (canvas, vcRegion.Area (canvas));
      }

togtext := vcRegion.Create ("toggle text", vcStaticText.fac, "Toggle Buttons");

tog1 := vcRegion.Create ("toggle 1", vcToggleButton.fac, TRUE, 
                  label <- "box", macro_on <- TRUE,
                  action <- act);
function act2 (ev, val) {
                     show_circle = val;
                     vcRegion.Refresh (canvas, vcRegion.Area (canvas));
                  }
tog2 := vcRegion.Create ("toggle 2", vcToggleButton.fac, FALSE,
                  label <- "oval", macro_on <- TRUE,
                  action <- act2);
vcTable.Add (lefttab, togtext);
vcTable.Add (lefttab, tog1);
vcTable.Add (lefttab, tog2);

vcTable.Add (bigtab, lefttab);
vcTable.Add (bigtab, righttab);

border := vcRegion.Create ("border", vcBorder.fac, canvas,
           border_style <- vcBorderStyle.EtchedOut, rounded <- FALSE,
           left_space <- 5, right_space <- 5, width <- 2,
           top_space <- 5, bottom_space <- 5);
margin := vcRegion.Create ("margin", vcMargin.fac, border,
          top_margin <- 15, bottom_margin <- 15, left_margin <- 15,
            right_margin <- 15); 
vcTable.Add (biggertab, bigtab);
vcTable.Add (biggertab, margin);
w := vcWin.Create (biggertab);

