package pack_t is

constant top_stack : integer := 50;
type s_array is array(1 to top_stack) of integer;
type stack is record
    id : character;
    sp : integer;
    s  : s_array;
end record;

function is_empty(s : stack) return boolean;

function is_full(s : stack) return boolean;

procedure push(s : inout stack; item : in integer);

procedure pop(s : inout stack; item : out integer);

procedure copy(f : in stack; t : out stack);

procedure add(s : inout stack);

procedure print(s : in stack);

end pack_t;


package body pack_t is 

-- is_empty
--
function is_empty(s : stack) return boolean is

begin
    if (s.sp = 0) then
        put("Stack ", s.id); putline(" Is Empty");
        return (TRUE);
    end if;
    return (FALSE);
end;

-- is_full
--
function is_full(s : stack) return boolean is

begin 
    if (s.sp = top_stack) then
        put("Stack ",s.id); putline(" Is Full");
        return(TRUE);
    end if;
    return(FALSE);
end;

-- push
--
procedure push(s : inout stack; item : in integer) is

begin
    if (not(is_full(s))) then
        s.sp := s.sp + 1;
        s.s(s.sp) := item;
    end if;
end;

-- pop
--
procedure pop(s : inout stack; item : out integer) is

begin
    if (not(is_empty(s))) then
        item := s.s(s.sp);
        s.sp := s.sp - 1;
    end if;
end;

-- copy
-- 
procedure copy(f : in stack; t : out stack) is

begin
    for i in 1 to f.sp loop
        t.s(i) := f.s(i);
    end loop;
    t.sp := f.sp;
end;

-- add
--
procedure add(s : inout stack) is
    variable a,b,c : integer;
begin
    if not(is_empty(s)) then
        pop(s,a);
        if not(is_empty(s)) then
            pop(s,b);
            c := a + b;
            push(s,c);
        end if;
    end if;
end;

-- print
--
procedure print(s : in stack)is

begin
    if not(is_empty(s)) then
        putline("Stack ", s.id);
        putline("_______");
        for i in s.sp downto 1 loop
            put("position :", i); putline(" :: ",s.s(i));
        end loop;
    end if;
end;
end pack_t;

